# azure.mgmt.apimanagement.models module

exception `azure.mgmt.apimanagement.models.``ErrorResponseException`(deserialize, response, *args)

  Bases: `msrest.exceptions.HttpOperationError`

  Server responsed with exception of type: ‘ErrorResponse’.

  Parameters:

  - deserialize – A deserializer
  - response – Server response to be deserialized.

class `azure.mgmt.apimanagement.models.``ErrorFieldContract`(*, code: str = None, message: str = None, target: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Error Field contract.

  Parameters:

  - code (str) – Property level error code.
  - message (str) – Human-readable representation of property-level error.
  - target (str) – Property name.

class `azure.mgmt.apimanagement.models.``ErrorResponseBody`(*, code: str = None, message: str = None, details=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Error Body contract.

  Parameters:

  - code (str) – Service-defined error code. This code serves as a sub-status for the HTTP error code specified in the response.
  - message (str) – Human-readable representation of the error.
  - details (list[ErrorFieldContract]) – The list of invalid fields send in request, in case of validation error.

class `azure.mgmt.apimanagement.models.``ErrorResponse`(*, code: str = None, message: str = None, details=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Error Response.

  Parameters:

  - code (str) – Service-defined error code. This code serves as a sub-status for the HTTP error code specified in the response.
  - message (str) – Human-readable representation of the error.
  - details (list[ErrorFieldContract]) – The list of invalid fields send in request, in case of validation error.

class `azure.mgmt.apimanagement.models.``RegionContract`(*, is_master_region: bool = None, is_deleted: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Region profile.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables: | name (str) – Region name.

  Parameters:

  - is_master_region (bool) – whether Region is the master region.
  - is_deleted (bool) – whether Region is deleted.

class `azure.mgmt.apimanagement.models.``Resource`(**kwargs)

  Bases: `msrest.serialization.Model`

  The Resource definition.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

class `azure.mgmt.apimanagement.models.``ApiExportResultValue`(*, link: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  The object defining the schema of the exported Api Detail.

  Parameters: | link (str) – Link to the Storage Blob containing the result of the export operation. The Blob Uri is only valid for 5 minutes.

class `azure.mgmt.apimanagement.models.``ApiExportResult`(*, id: str = None, export_result_format=None, value=None, **kwargs)

  Bases: `msrest.serialization.Model`

  API Export result.

  Parameters:

  - id (str) – ResourceId of the API which was exported.
  - export_result_format (str or ExportResultFormat) – Format in which the Api Details are exported to the Storage Blob with Sas Key valid for 5 minutes. Possible values include: ‘Swagger’, ‘Wsdl’, ‘Wadl’, ‘OpenApi’
  - value (ApiExportResultValue) – The object defining the schema of the exported Api Detail

class `azure.mgmt.apimanagement.models.``ProductEntityBaseParameters`(*, description: str = None, terms: str = None, subscription_required: bool = None, approval_required: bool = None, subscriptions_limit: int = None, state=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Product Entity Base Parameters.

  Parameters:

  - description (str) – Product description. May include HTML formatting tags.
  - terms (str) – Product terms of use. Developers trying to subscribe to the product will be presented and required to accept these terms before they can complete the subscription process.
  - subscription_required (bool) – Whether a product subscription is required for accessing APIs included in this product. If true, the product is referred to as “protected” and a valid subscription key is required for a request to an API included in the product to succeed. If false, the product is referred to as “open” and requests to an API included in the product can be made without a subscription key. If property is omitted when creating a new product it’s value is assumed to be true.
  - approval_required (bool) – whether subscription approval is required. If false, new subscriptions will be approved automatically enabling developers to call the product’s APIs immediately after subscribing. If true, administrators must manually approve the subscription before the developer can any of the product’s APIs. Can be present only if subscriptionRequired property is present and has a value of false.
  - subscriptions_limit (int) – Whether the number of subscriptions a user can have to this product at the same time. Set to null or omit to allow unlimited per user subscriptions. Can be present only if subscriptionRequired property is present and has a value of false.
  - state (str or ProductState) – whether product is published or not. Published products are discoverable by users of developer portal. Non published products are visible only to administrators. Default state of Product is notPublished. Possible values include: ‘notPublished’, ‘published’

class `azure.mgmt.apimanagement.models.``ProductTagResourceContractProperties`(*, name: str, description: str = None, terms: str = None, subscription_required: bool = None, approval_required: bool = None, subscriptions_limit: int = None, state=None, id: str = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.product_entity_base_parameters_py3.ProductEntityBaseParameters`

  Product profile.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - description (str) – Product description. May include HTML formatting tags.
  - terms (str) – Product terms of use. Developers trying to subscribe to the product will be presented and required to accept these terms before they can complete the subscription process.
  - subscription_required (bool) – Whether a product subscription is required for accessing APIs included in this product. If true, the product is referred to as “protected” and a valid subscription key is required for a request to an API included in the product to succeed. If false, the product is referred to as “open” and requests to an API included in the product can be made without a subscription key. If property is omitted when creating a new product it’s value is assumed to be true.
  - approval_required (bool) – whether subscription approval is required. If false, new subscriptions will be approved automatically enabling developers to call the product’s APIs immediately after subscribing. If true, administrators must manually approve the subscription before the developer can any of the product’s APIs. Can be present only if subscriptionRequired property is present and has a value of false.
  - subscriptions_limit (int) – Whether the number of subscriptions a user can have to this product at the same time. Set to null or omit to allow unlimited per user subscriptions. Can be present only if subscriptionRequired property is present and has a value of false.
  - state (str or ProductState) – whether product is published or not. Published products are discoverable by users of developer portal. Non published products are visible only to administrators. Default state of Product is notPublished. Possible values include: ‘notPublished’, ‘published’
  - id (str) – Identifier of the product in the form of /products/{productId}
  - name (str) – Required. Product name.

class `azure.mgmt.apimanagement.models.``OperationTagResourceContractProperties`(*, id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Operation Entity contract Properties.

  Variables are only populated by the server, and will be ignored when sending a request.

  Parameters: | id (str) – Identifier of the operation in form /operations/{operationId}.

  Variables:

  - name (str) – Operation name.
  - api_name (str) – Api Name.
  - api_revision (str) – Api Revision.
  - api_version (str) – Api Version.
  - description (str) – Operation Description.
  - method (str) – A Valid HTTP Operation Method. Typical Http Methods like GET, PUT, POST but not limited by only them.
  - url_template (str) – Relative URL template identifying the target resource for this operation. May include parameters. Example: /customers/{cid}/orders/{oid}/?date={date}

class `azure.mgmt.apimanagement.models.``SubscriptionKeyParameterNamesContract`(*, header: str = None, query: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Subscription key parameter names details.

  Parameters:

  - header (str) – Subscription key header name.
  - query (str) – Subscription key query string parameter name.

class `azure.mgmt.apimanagement.models.``OpenIdAuthenticationSettingsContract`(*, openid_provider_id: str = None, bearer_token_sending_methods=None, **kwargs)

  Bases: `msrest.serialization.Model`

  API OAuth2 Authentication settings details.

  Parameters:

  - openid_provider_id (str) – OAuth authorization server identifier.
  - bearer_token_sending_methods (list[str or BearerTokenSendingMethods]) – How to send token to the server.

class `azure.mgmt.apimanagement.models.``OAuth2AuthenticationSettingsContract`(*, authorization_server_id: str = None, scope: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  API OAuth2 Authentication settings details.

  Parameters:

  - authorization_server_id (str) – OAuth authorization server identifier.
  - scope (str) – operations scope.

class `azure.mgmt.apimanagement.models.``AuthenticationSettingsContract`(*, o_auth2=None, openid=None, subscription_key_required: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  API Authentication Settings.

  Parameters:

  - o_auth2 (OAuth2AuthenticationSettingsContract) – OAuth2 Authentication settings
  - openid (OpenIdAuthenticationSettingsContract) – OpenID Connect Authentication Settings
  - subscription_key_required (bool) – Specifies whether subscription key is required during call to this API, true - API is included into closed products only, false - API is included into open products alone, null - there is a mix of products.

class `azure.mgmt.apimanagement.models.``ApiVersionSetContractDetails`(*, id: str = None, name: str = None, description: str = None, versioning_scheme=None, version_query_name: str = None, version_header_name: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  An API Version Set contains the common configuration for a set of API Versions relating .

  Parameters:

  - id (str) – Identifier for existing API Version Set. Omit this value to create a new Version Set.
  - name (str) – The display Name of the API Version Set.
  - description (str) – Description of API Version Set.
  - versioning_scheme (str or enum) – An value that determines where the API Version identifer will be located in a HTTP request. Possible values include: ‘Segment’, ‘Query’, ‘Header’
  - version_query_name (str) – Name of query parameter that indicates the API Version if versioningScheme is set to query.
  - version_header_name (str) – Name of HTTP header parameter that indicates the API Version if versioningScheme is set to header.

class `azure.mgmt.apimanagement.models.``ApiCreateOrUpdatePropertiesWsdlSelector`(*, wsdl_service_name: str = None, wsdl_endpoint_name: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Criteria to limit import of WSDL to a subset of the document.

  Parameters:

  - wsdl_service_name (str) – Name of service to import from WSDL
  - wsdl_endpoint_name (str) – Name of endpoint(port) to import from WSDL

class `azure.mgmt.apimanagement.models.``ApiContractProperties`(*, path: str, description: str = None, authentication_settings=None, subscription_key_parameter_names=None, api_type=None, api_revision: str = None, api_version: str = None, is_current: bool = None, api_revision_description: str = None, api_version_description: str = None, api_version_set_id: str = None, subscription_required: bool = None, source_api_id: str = None, display_name: str = None, service_url: str = None, protocols=None, api_version_set=None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.api_entity_base_contract_py3.ApiEntityBaseContract`

  Api Entity Properties.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - description (str) – Description of the API. May include HTML formatting tags.
  - authentication_settings (AuthenticationSettingsContract) – Collection of authentication settings included into this API.
  - subscription_key_parameter_names (SubscriptionKeyParameterNamesContract) – Protocols over which API is made available.
  - api_type (str or ApiType) – Type of API. Possible values include: ‘http’, ‘soap’
  - api_revision (str) – Describes the Revision of the Api. If no value is provided, default revision 1 is created
  - api_version (str) – Indicates the Version identifier of the API if the API is versioned
  - is_current (bool) – Indicates if API revision is current api revision.
  - api_revision_description (str) – Description of the Api Revision.
  - api_version_description (str) – Description of the Api Version.
  - api_version_set_id (str) – A resource identifier for the related ApiVersionSet.
  - subscription_required (bool) – Specifies whether an API or Product subscription is required for accessing the API.
  - source_api_id (str) – API identifier of the source API.
  - display_name (str) – API name. Must be 1 to 300 characters long.
  - service_url (str) – Absolute URL of the backend service implementing this API. Cannot be more than 2000 characters long.
  - path (str) – Required. Relative URL uniquely identifying this API and all of its resource paths within the API Management service instance. It is appended to the API endpoint base URL specified during the service instance creation to form a public URL for this API.
  - protocols (list[str or Protocol]) – Describes on which protocols the operations in this API can be invoked.
  - api_version_set (ApiVersionSetContractDetails) – Version set details

  Variables: | is_online (bool) – Indicates if API revision is accessible via the gateway.

class `azure.mgmt.apimanagement.models.``ApiEntityBaseContract`(*, description: str = None, authentication_settings=None, subscription_key_parameter_names=None, api_type=None, api_revision: str = None, api_version: str = None, is_current: bool = None, api_revision_description: str = None, api_version_description: str = None, api_version_set_id: str = None, subscription_required: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  API base contract details.

  Variables are only populated by the server, and will be ignored when sending a request.

  Parameters:

  - description (str) – Description of the API. May include HTML formatting tags.
  - authentication_settings (AuthenticationSettingsContract) – Collection of authentication settings included into this API.
  - subscription_key_parameter_names (SubscriptionKeyParameterNamesContract) – Protocols over which API is made available.
  - api_type (str or ApiType) – Type of API. Possible values include: ‘http’, ‘soap’
  - api_revision (str) – Describes the Revision of the Api. If no value is provided, default revision 1 is created
  - api_version (str) – Indicates the Version identifier of the API if the API is versioned
  - is_current (bool) – Indicates if API revision is current api revision.
  - api_revision_description (str) – Description of the Api Revision.
  - api_version_description (str) – Description of the Api Version.
  - api_version_set_id (str) – A resource identifier for the related ApiVersionSet.
  - subscription_required (bool) – Specifies whether an API or Product subscription is required for accessing the API.

  Variables: | is_online (bool) – Indicates if API revision is accessible via the gateway.

class `azure.mgmt.apimanagement.models.``ApiTagResourceContractProperties`(*, description: str = None, authentication_settings=None, subscription_key_parameter_names=None, api_type=None, api_revision: str = None, api_version: str = None, is_current: bool = None, api_revision_description: str = None, api_version_description: str = None, api_version_set_id: str = None, subscription_required: bool = None, id: str = None, name: str = None, service_url: str = None, path: str = None, protocols=None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.api_entity_base_contract_py3.ApiEntityBaseContract`

  API contract properties for the Tag Resources.

  Variables are only populated by the server, and will be ignored when sending a request.

  Parameters:

  - description (str) – Description of the API. May include HTML formatting tags.
  - authentication_settings (AuthenticationSettingsContract) – Collection of authentication settings included into this API.
  - subscription_key_parameter_names (SubscriptionKeyParameterNamesContract) – Protocols over which API is made available.
  - api_type (str or ApiType) – Type of API. Possible values include: ‘http’, ‘soap’
  - api_revision (str) – Describes the Revision of the Api. If no value is provided, default revision 1 is created
  - api_version (str) – Indicates the Version identifier of the API if the API is versioned
  - is_current (bool) – Indicates if API revision is current api revision.
  - api_revision_description (str) – Description of the Api Revision.
  - api_version_description (str) – Description of the Api Version.
  - api_version_set_id (str) – A resource identifier for the related ApiVersionSet.
  - subscription_required (bool) – Specifies whether an API or Product subscription is required for accessing the API.
  - id (str) – API identifier in the form /apis/{apiId}.
  - name (str) – API name.
  - service_url (str) – Absolute URL of the backend service implementing this API.
  - path (str) – Relative URL uniquely identifying this API and all of its resource paths within the API Management service instance. It is appended to the API endpoint base URL specified during the service instance creation to form a public URL for this API.
  - protocols (list[str or Protocol]) – Describes on which protocols the operations in this API can be invoked.

  Variables: | is_online (bool) – Indicates if API revision is accessible via the gateway.

class `azure.mgmt.apimanagement.models.``TagTagResourceContractProperties`(*, id: str = None, name: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Contract defining the Tag property in the Tag Resource Contract.

  Parameters:

  - id (str) – Tag identifier
  - name (str) – Tag Name

class `azure.mgmt.apimanagement.models.``TagResourceContract`(*, tag, api=None, operation=None, product=None, **kwargs)

  Bases: `msrest.serialization.Model`

  TagResource contract properties.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - tag (TagTagResourceContractProperties) – Required. Tag associated with the resource.
  - api (ApiTagResourceContractProperties) – Api associated with the tag.
  - operation (OperationTagResourceContractProperties) – Operation associated with the tag.
  - product (ProductTagResourceContractProperties) – Product associated with the tag.

class `azure.mgmt.apimanagement.models.``TagContract`(*, display_name: str, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Tag Contract details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters: | display_name (str) – Required. Tag name.

class `azure.mgmt.apimanagement.models.``TagDescriptionContract`(*, description: str = None, external_docs_url: str = None, external_docs_description: str = None, display_name: str = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Contract details.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - description (str) – Description of the Tag.
  - external_docs_url (str) – Absolute URL of external resources describing the tag.
  - external_docs_description (str) – Description of the external resources describing the tag.
  - display_name (str) – Tag name.

class `azure.mgmt.apimanagement.models.``TagDescriptionCreateParameters`(*, description: str = None, external_docs_url: str = None, external_docs_description: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Parameters supplied to the Create TagDescription operation.

  Parameters:

  - description (str) – Description of the Tag.
  - external_docs_url (str) – Absolute URL of external resources describing the tag.
  - external_docs_description (str) – Description of the external resources describing the tag.

class `azure.mgmt.apimanagement.models.``IssueAttachmentContract`(*, title: str, content_format: str, content: str, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Issue Attachment Contract details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - title (str) – Required. Filename by which the binary data will be saved.
  - content_format (str) – Required. Either ‘link’ if content is provided via an HTTP link or the MIME type of the Base64-encoded binary data provided in the ‘content’ property.
  - content (str) – Required. An HTTP link or Base64-encoded binary data.

class `azure.mgmt.apimanagement.models.``IssueCommentContract`(*, text: str, user_id: str, created_date=None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Issue Comment Contract details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - text (str) – Required. Comment text.
  - created_date (datetime) – Date and time when the comment was created.
  - user_id (str) – Required. A resource identifier for the user who left the comment.

class `azure.mgmt.apimanagement.models.``IssueContractBaseProperties`(*, created_date=None, state=None, api_id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Issue contract Base Properties.

  Parameters:

  - created_date (datetime) – Date and time when the issue was created.
  - state (str or State) – Status of the issue. Possible values include: ‘proposed’, ‘open’, ‘removed’, ‘resolved’, ‘closed’
  - api_id (str) – A resource identifier for the API the issue was created for.

class `azure.mgmt.apimanagement.models.``IssueUpdateContract`(*, created_date=None, state=None, api_id: str = None, title: str = None, description: str = None, user_id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Issue update Parameters.

  Parameters:

  - created_date (datetime) – Date and time when the issue was created.
  - state (str or State) – Status of the issue. Possible values include: ‘proposed’, ‘open’, ‘removed’, ‘resolved’, ‘closed’
  - api_id (str) – A resource identifier for the API the issue was created for.
  - title (str) – The issue title.
  - description (str) – Text describing the issue.
  - user_id (str) – A resource identifier for the user created the issue.

class `azure.mgmt.apimanagement.models.``IssueContract`(*, title: str, description: str, user_id: str, created_date=None, state=None, api_id: str = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Issue Contract details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - created_date (datetime) – Date and time when the issue was created.
  - state (str or State) – Status of the issue. Possible values include: ‘proposed’, ‘open’, ‘removed’, ‘resolved’, ‘closed’
  - api_id (str) – A resource identifier for the API the issue was created for.
  - title (str) – Required. The issue title.
  - description (str) – Required. Text describing the issue.
  - user_id (str) – Required. A resource identifier for the user created the issue.

class `azure.mgmt.apimanagement.models.``BodyDiagnosticSettings`(*, bytes: int = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Body logging settings.

  Parameters: | bytes (int) – Number of request body bytes to log.

class `azure.mgmt.apimanagement.models.``HttpMessageDiagnostic`(*, headers=None, body=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Http message diagnostic settings.

  Parameters:

  - headers (list[str]) – Array of HTTP Headers to log.
  - body (BodyDiagnosticSettings) – Body logging settings.

class `azure.mgmt.apimanagement.models.``PipelineDiagnosticSettings`(*, request=None, response=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Diagnostic settings for incoming/outgoing HTTP messages to the Gateway.

  Parameters:

  - request (HttpMessageDiagnostic) – Diagnostic settings for request.
  - response (HttpMessageDiagnostic) – Diagnostic settings for response.

class `azure.mgmt.apimanagement.models.``SamplingSettings`(*, sampling_type=None, percentage: float = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Sampling settings for Diagnostic.

  Parameters:

  - sampling_type (str or SamplingType) – Sampling type. Possible values include: ‘fixed’
  - percentage (float) – Rate of sampling for fixed-rate sampling.

class `azure.mgmt.apimanagement.models.``DiagnosticContract`(*, logger_id: str, always_log=None, sampling=None, frontend=None, backend=None, enable_http_correlation_headers: bool = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Diagnostic details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - always_log (str or AlwaysLog) – Specifies for what type of messages sampling settings should not apply. Possible values include: ‘allErrors’
  - logger_id (str) – Required. Resource Id of a target logger.
  - sampling (SamplingSettings) – Sampling settings for Diagnostic.
  - frontend (PipelineDiagnosticSettings) – Diagnostic settings for incoming/outgoing HTTP messages to the Gateway.
  - backend (PipelineDiagnosticSettings) – Diagnostic settings for incoming/outgoing HTTP messages to the Backend
  - enable_http_correlation_headers (bool) – Whether to process Correlation Headers coming to Api Management Service. Only applicable to Application Insights diagnostics. Default is true.

class `azure.mgmt.apimanagement.models.``SchemaContract`(*, content_type: str, document=None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Schema Contract details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - content_type (str) – Required. Must be a valid a media type used in a Content-Type header as defined in the RFC 2616. Media type of the schema document (e.g. application/json, application/xml). </br> - Swagger Schema use application/vnd.ms-azure-apim.swagger.definitions+json </br> - WSDL Schema use application/vnd.ms-azure-apim.xsd+xml </br> - OpenApi Schema use application/vnd.oai.openapi.components+json </br> - WADL Schema use application/vnd.ms-azure-apim.wadl.grammars+xml.
  - document (object) – Properties of the Schema Document.

class `azure.mgmt.apimanagement.models.``SchemaCreateOrUpdateContract`(*, content_type: str, value: str = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Schema Contract details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - content_type (str) – Required. Must be a valid a media type used in a Content-Type header as defined in the RFC 2616. Media type of the schema document (e.g. application/json, application/xml). </br> - Swagger Schema use application/vnd.ms-azure-apim.swagger.definitions+json </br> - WSDL Schema use application/vnd.ms-azure-apim.xsd+xml </br> - OpenApi Schema use application/vnd.oai.openapi.components+json </br> - WADL Schema use application/vnd.ms-azure-apim.wadl.grammars+xml.
  - value (str) – Json escaped string defining the document representing the Schema.

class `azure.mgmt.apimanagement.models.``PolicyContract`(*, value: str, format='xml', **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Policy Contract details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - value (str) – Required. Contents of the Policy as defined by the format.
  - format (str or PolicyContentFormat) – Format of the policyContent. Possible values include: ‘xml’, ‘xml-link’, ‘rawxml’, ‘rawxml-link’. Default value: “xml” .

class `azure.mgmt.apimanagement.models.``PolicyCollection`(*, value=None, next_link: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  The response of the list policy operation.

  Parameters:

  - value (list[PolicyContract]) – Policy Contract value.
  - next_link (str) – Next page link if any.

class `azure.mgmt.apimanagement.models.``ProductContract`(*, display_name: str, description: str = None, terms: str = None, subscription_required: bool = None, approval_required: bool = None, subscriptions_limit: int = None, state=None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Product details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - description (str) – Product description. May include HTML formatting tags.
  - terms (str) – Product terms of use. Developers trying to subscribe to the product will be presented and required to accept these terms before they can complete the subscription process.
  - subscription_required (bool) – Whether a product subscription is required for accessing APIs included in this product. If true, the product is referred to as “protected” and a valid subscription key is required for a request to an API included in the product to succeed. If false, the product is referred to as “open” and requests to an API included in the product can be made without a subscription key. If property is omitted when creating a new product it’s value is assumed to be true.
  - approval_required (bool) – whether subscription approval is required. If false, new subscriptions will be approved automatically enabling developers to call the product’s APIs immediately after subscribing. If true, administrators must manually approve the subscription before the developer can any of the product’s APIs. Can be present only if subscriptionRequired property is present and has a value of false.
  - subscriptions_limit (int) – Whether the number of subscriptions a user can have to this product at the same time. Set to null or omit to allow unlimited per user subscriptions. Can be present only if subscriptionRequired property is present and has a value of false.
  - state (str or ProductState) – whether product is published or not. Published products are discoverable by users of developer portal. Non published products are visible only to administrators. Default state of Product is notPublished. Possible values include: ‘notPublished’, ‘published’
  - display_name (str) – Required. Product name.

class `azure.mgmt.apimanagement.models.``ParameterContract`(*, name: str, type: str, description: str = None, default_value: str = None, required: bool = None, values=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Operation parameters details.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Parameter name.
  - description (str) – Parameter description.
  - type (str) – Required. Parameter type.
  - default_value (str) – Default parameter value.
  - required (bool) – Specifies whether parameter is required or not.
  - values (list[str]) – Parameter values.

class `azure.mgmt.apimanagement.models.``RepresentationContract`(*, content_type: str, sample: str = None, schema_id: str = None, type_name: str = None, form_parameters=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Operation request/response representation details.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - content_type (str) – Required. Specifies a registered or custom content type for this representation, e.g. application/xml.
  - sample (str) – An example of the representation.
  - schema_id (str) – Schema identifier. Applicable only if ‘contentType’ value is neither ‘application/x-www-form-urlencoded’ nor ‘multipart/form-data’.
  - type_name (str) – Type name defined by the schema. Applicable only if ‘contentType’ value is neither ‘application/x-www-form-urlencoded’ nor ‘multipart/form-data’.
  - form_parameters (list[ParameterContract]) – Collection of form parameters. Required if ‘contentType’ value is either ‘application/x-www-form-urlencoded’ or ‘multipart/form-data’..

class `azure.mgmt.apimanagement.models.``ResponseContract`(*, status_code: int, description: str = None, representations=None, headers=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Operation response details.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - status_code (int) – Required. Operation response HTTP status code.
  - description (str) – Operation response description.
  - representations (list[RepresentationContract]) – Collection of operation response representations.
  - headers (list[ParameterContract]) – Collection of operation response headers.

class `azure.mgmt.apimanagement.models.``RequestContract`(*, description: str = None, query_parameters=None, headers=None, representations=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Operation request details.

  Parameters:

  - description (str) – Operation request description.
  - query_parameters (list[ParameterContract]) – Collection of operation request query parameters.
  - headers (list[ParameterContract]) – Collection of operation request headers.
  - representations (list[RepresentationContract]) – Collection of operation request representations.

class `azure.mgmt.apimanagement.models.``OperationEntityBaseContract`(*, template_parameters=None, description: str = None, request=None, responses=None, policies: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Api Operation Entity Base Contract details.

  Parameters:

  - template_parameters (list[ParameterContract]) – Collection of URL template parameters.
  - description (str) – Description of the operation. May include HTML formatting tags.
  - request (RequestContract) – An entity containing request details.
  - responses (list[ResponseContract]) – Array of Operation responses.
  - policies (str) – Operation Policies

class `azure.mgmt.apimanagement.models.``OperationUpdateContract`(*, template_parameters=None, description: str = None, request=None, responses=None, policies: str = None, display_name: str = None, method: str = None, url_template: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Api Operation Update Contract details.

  Parameters:

  - template_parameters (list[ParameterContract]) – Collection of URL template parameters.
  - description (str) – Description of the operation. May include HTML formatting tags.
  - request (RequestContract) – An entity containing request details.
  - responses (list[ResponseContract]) – Array of Operation responses.
  - policies (str) – Operation Policies
  - display_name (str) – Operation Name.
  - method (str) – A Valid HTTP Operation Method. Typical Http Methods like GET, PUT, POST but not limited by only them.
  - url_template (str) – Relative URL template identifying the target resource for this operation. May include parameters. Example: /customers/{cid}/orders/{oid}/?date={date}

class `azure.mgmt.apimanagement.models.``OperationContract`(*, display_name: str, method: str, url_template: str, template_parameters=None, description: str = None, request=None, responses=None, policies: str = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Api Operation details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - template_parameters (list[ParameterContract]) – Collection of URL template parameters.
  - description (str) – Description of the operation. May include HTML formatting tags.
  - request (RequestContract) – An entity containing request details.
  - responses (list[ResponseContract]) – Array of Operation responses.
  - policies (str) – Operation Policies
  - display_name (str) – Required. Operation Name.
  - method (str) – Required. A Valid HTTP Operation Method. Typical Http Methods like GET, PUT, POST but not limited by only them.
  - url_template (str) – Required. Relative URL template identifying the target resource for this operation. May include parameters. Example: /customers/{cid}/orders/{oid}/?date={date}

class `azure.mgmt.apimanagement.models.``ApiReleaseContract`(*, api_id: str = None, notes: str = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  ApiRelease details.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.
  - created_date_time (datetime) – The time the API was released. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.
  - updated_date_time (datetime) – The time the API release was updated.

  Parameters:

  - api_id (str) – Identifier of the API the release belongs to.
  - notes (str) – Release Notes

class `azure.mgmt.apimanagement.models.``ApiRevisionContract`(**kwargs)

  Bases: `msrest.serialization.Model`

  Summary of revision metadata.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - api_id (str) – Identifier of the API Revision.
  - api_revision (str) – Revision number of API.
  - created_date_time (datetime) – The time the API Revision was created. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.
  - updated_date_time (datetime) – The time the API Revision were updated. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.
  - description (str) – Description of the API Revision.
  - private_url (str) – Gateway URL for accessing the non-current API Revision.
  - is_online (bool) – Indicates if API revision is the current api revision.
  - is_current (bool) – Indicates if API revision is accessible via the gateway.

class `azure.mgmt.apimanagement.models.``ApiUpdateContract`(*, description: str = None, authentication_settings=None, subscription_key_parameter_names=None, api_type=None, api_revision: str = None, api_version: str = None, is_current: bool = None, api_revision_description: str = None, api_version_description: str = None, api_version_set_id: str = None, subscription_required: bool = None, display_name: str = None, service_url: str = None, path: str = None, protocols=None, **kwargs)

  Bases: `msrest.serialization.Model`

  API update contract details.

  Variables are only populated by the server, and will be ignored when sending a request.

  Parameters:

  - description (str) – Description of the API. May include HTML formatting tags.
  - authentication_settings (AuthenticationSettingsContract) – Collection of authentication settings included into this API.
  - subscription_key_parameter_names (SubscriptionKeyParameterNamesContract) – Protocols over which API is made available.
  - api_type (str or ApiType) – Type of API. Possible values include: ‘http’, ‘soap’
  - api_revision (str) – Describes the Revision of the Api. If no value is provided, default revision 1 is created
  - api_version (str) – Indicates the Version identifier of the API if the API is versioned
  - is_current (bool) – Indicates if API revision is current api revision.
  - api_revision_description (str) – Description of the Api Revision.
  - api_version_description (str) – Description of the Api Version.
  - api_version_set_id (str) – A resource identifier for the related ApiVersionSet.
  - subscription_required (bool) – Specifies whether an API or Product subscription is required for accessing the API.
  - display_name (str) – API name.
  - service_url (str) – Absolute URL of the backend service implementing this API.
  - path (str) – Relative URL uniquely identifying this API and all of its resource paths within the API Management service instance. It is appended to the API endpoint base URL specified during the service instance creation to form a public URL for this API.
  - protocols (list[str or Protocol]) – Describes on which protocols the operations in this API can be invoked.

  Variables: | is_online (bool) – Indicates if API revision is accessible via the gateway.

class `azure.mgmt.apimanagement.models.``ApiContract`(*, path: str, description: str = None, authentication_settings=None, subscription_key_parameter_names=None, api_type=None, api_revision: str = None, api_version: str = None, is_current: bool = None, api_revision_description: str = None, api_version_description: str = None, api_version_set_id: str = None, subscription_required: bool = None, source_api_id: str = None, display_name: str = None, service_url: str = None, protocols=None, api_version_set=None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Api details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.
  - is_online (bool) – Indicates if API revision is accessible via the gateway.

  Parameters:

  - description (str) – Description of the API. May include HTML formatting tags.
  - authentication_settings (AuthenticationSettingsContract) – Collection of authentication settings included into this API.
  - subscription_key_parameter_names (SubscriptionKeyParameterNamesContract) – Protocols over which API is made available.
  - api_type (str or ApiType) – Type of API. Possible values include: ‘http’, ‘soap’
  - api_revision (str) – Describes the Revision of the Api. If no value is provided, default revision 1 is created
  - api_version (str) – Indicates the Version identifier of the API if the API is versioned
  - is_current (bool) – Indicates if API revision is current api revision.
  - api_revision_description (str) – Description of the Api Revision.
  - api_version_description (str) – Description of the Api Version.
  - api_version_set_id (str) – A resource identifier for the related ApiVersionSet.
  - subscription_required (bool) – Specifies whether an API or Product subscription is required for accessing the API.
  - source_api_id (str) – API identifier of the source API.
  - display_name (str) – API name. Must be 1 to 300 characters long.
  - service_url (str) – Absolute URL of the backend service implementing this API. Cannot be more than 2000 characters long.
  - path (str) – Required. Relative URL uniquely identifying this API and all of its resource paths within the API Management service instance. It is appended to the API endpoint base URL specified during the service instance creation to form a public URL for this API.
  - protocols (list[str or Protocol]) – Describes on which protocols the operations in this API can be invoked.
  - api_version_set (ApiVersionSetContractDetails) – Version set details

class `azure.mgmt.apimanagement.models.``ApiCreateOrUpdateParameter`(*, path: str, description: str = None, authentication_settings=None, subscription_key_parameter_names=None, api_type=None, api_revision: str = None, api_version: str = None, is_current: bool = None, api_revision_description: str = None, api_version_description: str = None, api_version_set_id: str = None, subscription_required: bool = None, source_api_id: str = None, display_name: str = None, service_url: str = None, protocols=None, api_version_set=None, value: str = None, format=None, wsdl_selector=None, soap_api_type=None, **kwargs)

  Bases: `msrest.serialization.Model`

  API Create or Update Parameters.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - description (str) – Description of the API. May include HTML formatting tags.
  - authentication_settings (AuthenticationSettingsContract) – Collection of authentication settings included into this API.
  - subscription_key_parameter_names (SubscriptionKeyParameterNamesContract) – Protocols over which API is made available.
  - api_type (str or ApiType) – Type of API. Possible values include: ‘http’, ‘soap’
  - api_revision (str) – Describes the Revision of the Api. If no value is provided, default revision 1 is created
  - api_version (str) – Indicates the Version identifier of the API if the API is versioned
  - is_current (bool) – Indicates if API revision is current api revision.
  - api_revision_description (str) – Description of the Api Revision.
  - api_version_description (str) – Description of the Api Version.
  - api_version_set_id (str) – A resource identifier for the related ApiVersionSet.
  - subscription_required (bool) – Specifies whether an API or Product subscription is required for accessing the API.
  - source_api_id (str) – API identifier of the source API.
  - display_name (str) – API name. Must be 1 to 300 characters long.
  - service_url (str) – Absolute URL of the backend service implementing this API. Cannot be more than 2000 characters long.
  - path (str) – Required. Relative URL uniquely identifying this API and all of its resource paths within the API Management service instance. It is appended to the API endpoint base URL specified during the service instance creation to form a public URL for this API.
  - protocols (list[str or Protocol]) – Describes on which protocols the operations in this API can be invoked.
  - api_version_set (ApiVersionSetContractDetails) – Version set details
  - value (str) – Content value when Importing an API.
  - format (str or ContentFormat) – Format of the Content in which the API is getting imported. Possible values include: ‘wadl-xml’, ‘wadl-link-json’, ‘swagger-json’, ‘swagger-link-json’, ‘wsdl’, ‘wsdl-link’, ‘openapi’, ‘openapi+json’, ‘openapi-link’
  - wsdl_selector (ApiCreateOrUpdatePropertiesWsdlSelector) – Criteria to limit import of WSDL to a subset of the document.
  - soap_api_type (str or SoapApiType) – Type of Api to create. * http creates a SOAP to REST API * soap creates a SOAP pass-through API. Possible values include: ‘SoapToRest’, ‘SoapPassThrough’

  Variables: | is_online (bool) – Indicates if API revision is accessible via the gateway.

class `azure.mgmt.apimanagement.models.``ApiVersionSetEntityBase`(*, description: str = None, version_query_name: str = None, version_header_name: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Api Version set base parameters.

  Parameters:

  - description (str) – Description of API Version Set.
  - version_query_name (str) – Name of query parameter that indicates the API Version if versioningScheme is set to query.
  - version_header_name (str) – Name of HTTP header parameter that indicates the API Version if versioningScheme is set to header.

class `azure.mgmt.apimanagement.models.``ApiVersionSetUpdateParameters`(*, description: str = None, version_query_name: str = None, version_header_name: str = None, display_name: str = None, versioning_scheme=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Parameters to update or create an Api Version Set Contract.

  Parameters:

  - description (str) – Description of API Version Set.
  - version_query_name (str) – Name of query parameter that indicates the API Version if versioningScheme is set to query.
  - version_header_name (str) – Name of HTTP header parameter that indicates the API Version if versioningScheme is set to header.
  - display_name (str) – Name of API Version Set
  - versioning_scheme (str or VersioningScheme) – An value that determines where the API Version identifer will be located in a HTTP request. Possible values include: ‘Segment’, ‘Query’, ‘Header’

class `azure.mgmt.apimanagement.models.``ApiVersionSetContract`(*, display_name: str, versioning_scheme, description: str = None, version_query_name: str = None, version_header_name: str = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Api Version Set Contract details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - description (str) – Description of API Version Set.
  - version_query_name (str) – Name of query parameter that indicates the API Version if versioningScheme is set to query.
  - version_header_name (str) – Name of HTTP header parameter that indicates the API Version if versioningScheme is set to header.
  - display_name (str) – Required. Name of API Version Set
  - versioning_scheme (str or VersioningScheme) – Required. An value that determines where the API Version identifer will be located in a HTTP request. Possible values include: ‘Segment’, ‘Query’, ‘Header’

class `azure.mgmt.apimanagement.models.``TokenBodyParameterContract`(*, name: str, value: str, **kwargs)

  Bases: `msrest.serialization.Model`

  OAuth acquire token request body parameter (www-url-form-encoded).

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. body parameter name.
  - value (str) – Required. body parameter value.

class `azure.mgmt.apimanagement.models.``AuthorizationServerContractBaseProperties`(*, description: str = None, authorization_methods=None, client_authentication_method=None, token_body_parameters=None, token_endpoint: str = None, support_state: bool = None, default_scope: str = None, bearer_token_sending_methods=None, client_secret: str = None, resource_owner_username: str = None, resource_owner_password: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  External OAuth authorization server Update settings contract.

  Parameters:

  - description (str) – Description of the authorization server. Can contain HTML formatting tags.
  - authorization_methods (list[str or AuthorizationMethod]) – HTTP verbs supported by the authorization endpoint. GET must be always present. POST is optional.
  - client_authentication_method (list[str or ClientAuthenticationMethod]) – Method of authentication supported by the token endpoint of this authorization server. Possible values are Basic and/or Body. When Body is specified, client credentials and other parameters are passed within the request body in the application/x-www-form-urlencoded format.
  - token_body_parameters (list[TokenBodyParameterContract]) – Additional parameters required by the token endpoint of this authorization server represented as an array of JSON objects with name and value string properties, i.e. {“name” : “name value”, “value”: “a value”}.
  - token_endpoint (str) – OAuth token endpoint. Contains absolute URI to entity being referenced.
  - support_state (bool) – If true, authorization server will include state parameter from the authorization request to its response. Client may use state parameter to raise protocol security.
  - default_scope (str) – Access token scope that is going to be requested by default. Can be overridden at the API level. Should be provided in the form of a string containing space-delimited values.
  - bearer_token_sending_methods (list[str or BearerTokenSendingMethod]) – Specifies the mechanism by which access token is passed to the API.
  - client_secret (str) – Client or app secret registered with this authorization server.
  - resource_owner_username (str) – Can be optionally specified when resource owner password grant type is supported by this authorization server. Default resource owner username.
  - resource_owner_password (str) – Can be optionally specified when resource owner password grant type is supported by this authorization server. Default resource owner password.

class `azure.mgmt.apimanagement.models.``AuthorizationServerUpdateContract`(*, description: str = None, authorization_methods=None, client_authentication_method=None, token_body_parameters=None, token_endpoint: str = None, support_state: bool = None, default_scope: str = None, bearer_token_sending_methods=None, client_secret: str = None, resource_owner_username: str = None, resource_owner_password: str = None, display_name: str = None, client_registration_endpoint: str = None, authorization_endpoint: str = None, grant_types=None, client_id: str = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  External OAuth authorization server settings.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - description (str) – Description of the authorization server. Can contain HTML formatting tags.
  - authorization_methods (list[str or AuthorizationMethod]) – HTTP verbs supported by the authorization endpoint. GET must be always present. POST is optional.
  - client_authentication_method (list[str or ClientAuthenticationMethod]) – Method of authentication supported by the token endpoint of this authorization server. Possible values are Basic and/or Body. When Body is specified, client credentials and other parameters are passed within the request body in the application/x-www-form-urlencoded format.
  - token_body_parameters (list[TokenBodyParameterContract]) – Additional parameters required by the token endpoint of this authorization server represented as an array of JSON objects with name and value string properties, i.e. {“name” : “name value”, “value”: “a value”}.
  - token_endpoint (str) – OAuth token endpoint. Contains absolute URI to entity being referenced.
  - support_state (bool) – If true, authorization server will include state parameter from the authorization request to its response. Client may use state parameter to raise protocol security.
  - default_scope (str) – Access token scope that is going to be requested by default. Can be overridden at the API level. Should be provided in the form of a string containing space-delimited values.
  - bearer_token_sending_methods (list[str or BearerTokenSendingMethod]) – Specifies the mechanism by which access token is passed to the API.
  - client_secret (str) – Client or app secret registered with this authorization server.
  - resource_owner_username (str) – Can be optionally specified when resource owner password grant type is supported by this authorization server. Default resource owner username.
  - resource_owner_password (str) – Can be optionally specified when resource owner password grant type is supported by this authorization server. Default resource owner password.
  - display_name (str) – User-friendly authorization server name.
  - client_registration_endpoint (str) – Optional reference to a page where client or app registration for this authorization server is performed. Contains absolute URL to entity being referenced.
  - authorization_endpoint (str) – OAuth authorization endpoint. See http://tools.ietf.org/html/rfc6749#section-3.2.
  - grant_types (list[str or GrantType]) – Form of an authorization grant, which the client uses to request the access token.
  - client_id (str) – Client or app id registered with this authorization server.

class `azure.mgmt.apimanagement.models.``AuthorizationServerContract`(*, display_name: str, client_registration_endpoint: str, authorization_endpoint: str, grant_types, client_id: str, description: str = None, authorization_methods=None, client_authentication_method=None, token_body_parameters=None, token_endpoint: str = None, support_state: bool = None, default_scope: str = None, bearer_token_sending_methods=None, client_secret: str = None, resource_owner_username: str = None, resource_owner_password: str = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  External OAuth authorization server settings.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - description (str) – Description of the authorization server. Can contain HTML formatting tags.
  - authorization_methods (list[str or AuthorizationMethod]) – HTTP verbs supported by the authorization endpoint. GET must be always present. POST is optional.
  - client_authentication_method (list[str or ClientAuthenticationMethod]) – Method of authentication supported by the token endpoint of this authorization server. Possible values are Basic and/or Body. When Body is specified, client credentials and other parameters are passed within the request body in the application/x-www-form-urlencoded format.
  - token_body_parameters (list[TokenBodyParameterContract]) – Additional parameters required by the token endpoint of this authorization server represented as an array of JSON objects with name and value string properties, i.e. {“name” : “name value”, “value”: “a value”}.
  - token_endpoint (str) – OAuth token endpoint. Contains absolute URI to entity being referenced.
  - support_state (bool) – If true, authorization server will include state parameter from the authorization request to its response. Client may use state parameter to raise protocol security.
  - default_scope (str) – Access token scope that is going to be requested by default. Can be overridden at the API level. Should be provided in the form of a string containing space-delimited values.
  - bearer_token_sending_methods (list[str or BearerTokenSendingMethod]) – Specifies the mechanism by which access token is passed to the API.
  - client_secret (str) – Client or app secret registered with this authorization server.
  - resource_owner_username (str) – Can be optionally specified when resource owner password grant type is supported by this authorization server. Default resource owner username.
  - resource_owner_password (str) – Can be optionally specified when resource owner password grant type is supported by this authorization server. Default resource owner password.
  - display_name (str) – Required. User-friendly authorization server name.
  - client_registration_endpoint (str) – Required. Optional reference to a page where client or app registration for this authorization server is performed. Contains absolute URL to entity being referenced.
  - authorization_endpoint (str) – Required. OAuth authorization endpoint. See http://tools.ietf.org/html/rfc6749#section-3.2.
  - grant_types (list[str or GrantType]) – Required. Form of an authorization grant, which the client uses to request the access token.
  - client_id (str) – Required. Client or app id registered with this authorization server.

class `azure.mgmt.apimanagement.models.``BackendReconnectContract`(*, after=None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Reconnect request parameters.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters: | after (timedelta) – Duration in ISO8601 format after which reconnect will be initiated. Minimum duration of the Reconnect is PT2M.

class `azure.mgmt.apimanagement.models.``BackendTlsProperties`(*, validate_certificate_chain: bool = True, validate_certificate_name: bool = True, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties controlling TLS Certificate Validation.

  Parameters:

  - validate_certificate_chain (bool) – Flag indicating whether SSL certificate chain validation should be done when using self-signed certificates for this backend host. Default value: True .
  - validate_certificate_name (bool) – Flag indicating whether SSL certificate name validation should be done when using self-signed certificates for this backend host. Default value: True .

class `azure.mgmt.apimanagement.models.``BackendProxyContract`(*, url: str, username: str = None, password: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Details of the Backend WebProxy Server to use in the Request to Backend.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - url (str) – Required. WebProxy Server AbsoluteUri property which includes the entire URI stored in the Uri instance, including all fragments and query strings.
  - username (str) – Username to connect to the WebProxy server
  - password (str) – Password to connect to the WebProxy Server

class `azure.mgmt.apimanagement.models.``BackendAuthorizationHeaderCredentials`(*, scheme: str, parameter: str, **kwargs)

  Bases: `msrest.serialization.Model`

  Authorization header information.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - scheme (str) – Required. Authentication Scheme name.
  - parameter (str) – Required. Authentication Parameter value.

class `azure.mgmt.apimanagement.models.``BackendCredentialsContract`(*, certificate=None, query=None, header=None, authorization=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Details of the Credentials used to connect to Backend.

  Parameters:

  - certificate (list[str]) – List of Client Certificate Thumbprint.
  - query (dict[str, list[str]]) – Query Parameter description.
  - header (dict[str, list[str]]) – Header Parameter description.
  - authorization (BackendAuthorizationHeaderCredentials) – Authorization header authentication

class `azure.mgmt.apimanagement.models.``X509CertificateName`(*, name: str = None, issuer_certificate_thumbprint: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of server X509Names.

  Parameters:

  - name (str) – Common Name of the Certificate.
  - issuer_certificate_thumbprint (str) – Thumbprint for the Issuer of the Certificate.

class `azure.mgmt.apimanagement.models.``BackendServiceFabricClusterProperties`(*, client_certificatethumbprint: str, management_endpoints, max_partition_resolution_retries: int = None, server_certificate_thumbprints=None, server_x509_names=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of the Service Fabric Type Backend.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - client_certificatethumbprint (str) – Required. The client certificate thumbprint for the management endpoint.
  - max_partition_resolution_retries (int) – Maximum number of retries while attempting resolve the partition.
  - management_endpoints (list[str]) – Required. The cluster management endpoint.
  - server_certificate_thumbprints (list[str]) – Thumbprints of certificates cluster management service uses for tls communication
  - server_x509_names (list[X509CertificateName]) – Server X509 Certificate Names Collection

class `azure.mgmt.apimanagement.models.``BackendProperties`(*, service_fabric_cluster=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties specific to the Backend Type.

  Parameters: | service_fabric_cluster (BackendServiceFabricClusterProperties) – Backend Service Fabric Cluster Properties

class `azure.mgmt.apimanagement.models.``BackendBaseParameters`(*, title: str = None, description: str = None, resource_id: str = None, properties=None, credentials=None, proxy=None, tls=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Backend entity base Parameter set.

  Parameters:

  - title (str) – Backend Title.
  - description (str) – Backend Description.
  - resource_id (str) – Management Uri of the Resource in External System. This url can be the Arm Resource Id of Logic Apps, Function Apps or Api Apps.
  - properties (BackendProperties) – Backend Properties contract
  - credentials (BackendCredentialsContract) – Backend Credentials Contract Properties
  - proxy (BackendProxyContract) – Backend Proxy Contract Properties
  - tls (BackendTlsProperties) – Backend TLS Properties

class `azure.mgmt.apimanagement.models.``BackendUpdateParameters`(*, title: str = None, description: str = None, resource_id: str = None, properties=None, credentials=None, proxy=None, tls=None, url: str = None, protocol=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Backend update parameters.

  Parameters:

  - title (str) – Backend Title.
  - description (str) – Backend Description.
  - resource_id (str) – Management Uri of the Resource in External System. This url can be the Arm Resource Id of Logic Apps, Function Apps or Api Apps.
  - properties (BackendProperties) – Backend Properties contract
  - credentials (BackendCredentialsContract) – Backend Credentials Contract Properties
  - proxy (BackendProxyContract) – Backend Proxy Contract Properties
  - tls (BackendTlsProperties) – Backend TLS Properties
  - url (str) – Runtime Url of the Backend.
  - protocol (str or BackendProtocol) – Backend communication protocol. Possible values include: ‘http’, ‘soap’

class `azure.mgmt.apimanagement.models.``BackendContract`(*, url: str, protocol, title: str = None, description: str = None, resource_id: str = None, properties=None, credentials=None, proxy=None, tls=None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Backend details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - title (str) – Backend Title.
  - description (str) – Backend Description.
  - resource_id (str) – Management Uri of the Resource in External System. This url can be the Arm Resource Id of Logic Apps, Function Apps or Api Apps.
  - properties (BackendProperties) – Backend Properties contract
  - credentials (BackendCredentialsContract) – Backend Credentials Contract Properties
  - proxy (BackendProxyContract) – Backend Proxy Contract Properties
  - tls (BackendTlsProperties) – Backend TLS Properties
  - url (str) – Required. Runtime Url of the Backend.
  - protocol (str or BackendProtocol) – Required. Backend communication protocol. Possible values include: ‘http’, ‘soap’

class `azure.mgmt.apimanagement.models.``CacheUpdateParameters`(*, description: str = None, connection_string: str = None, resource_id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Cache update details.

  Parameters:

  - description (str) – Cache description
  - connection_string (str) – Runtime connection string to cache
  - resource_id (str) – Original uri of entity in external system cache points to

class `azure.mgmt.apimanagement.models.``CacheContract`(*, connection_string: str, description: str = None, resource_id: str = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Cache details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - description (str) – Cache description
  - connection_string (str) – Required. Runtime connection string to cache
  - resource_id (str) – Original uri of entity in external system cache points to

class `azure.mgmt.apimanagement.models.``CertificateContract`(*, subject: str, thumbprint: str, expiration_date, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Certificate details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - subject (str) – Required. Subject attribute of the certificate.
  - thumbprint (str) – Required. Thumbprint of the certificate.
  - expiration_date (datetime) – Required. Expiration date of the certificate. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.

class `azure.mgmt.apimanagement.models.``CertificateCreateOrUpdateParameters`(*, data: str, password: str, **kwargs)

  Bases: `msrest.serialization.Model`

  Certificate create or update details.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - data (str) – Required. Base 64 encoded certificate using the application/x-pkcs12 representation.
  - password (str) – Required. Password for the Certificate

class `azure.mgmt.apimanagement.models.``ResourceSku`(*, name=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Describes an available API Management SKU.

  Parameters: | name (str or SkuType) – Name of the Sku. Possible values include: ‘Developer’, ‘Standard’, ‘Premium’, ‘Basic’, ‘Consumption’

class `azure.mgmt.apimanagement.models.``ResourceSkuCapacity`(**kwargs)

  Bases: `msrest.serialization.Model`

  Describes scaling information of a SKU.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - minimum (int) – The minimum capacity.
  - maximum (int) – The maximum capacity that can be set.
  - default (int) – The default capacity.
  - scale_type (str or ResourceSkuCapacityScaleType) – The scale type applicable to the sku. Possible values include: ‘automatic’, ‘manual’, ‘none’

class `azure.mgmt.apimanagement.models.``ResourceSkuResult`(**kwargs)

  Bases: `msrest.serialization.Model`

  Describes an available API Management service SKU.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - resource_type (str) – The type of resource the SKU applies to.
  - sku (ResourceSku) – Specifies API Management SKU.
  - capacity (ResourceSkuCapacity) – Specifies the number of API Management units.

class `azure.mgmt.apimanagement.models.``CertificateInformation`(*, expiry, thumbprint: str, subject: str, **kwargs)

  Bases: `msrest.serialization.Model`

  SSL certificate information.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - expiry (datetime) – Required. Expiration date of the certificate. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.
  - thumbprint (str) – Required. Thumbprint of the certificate.
  - subject (str) – Required. Subject of the certificate.

class `azure.mgmt.apimanagement.models.``CertificateConfiguration`(*, store_name, encoded_certificate: str = None, certificate_password: str = None, certificate=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Certificate configuration which consist of non-trusted intermediates and root certificates.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - encoded_certificate (str) – Base64 Encoded certificate.
  - certificate_password (str) – Certificate Password.
  - store_name (str or enum) – Required. The System.Security.Cryptography.x509certificates.StoreName certificate store location. Only Root and CertificateAuthority are valid locations. Possible values include: ‘CertificateAuthority’, ‘Root’
  - certificate (CertificateInformation) – Certificate information.

class `azure.mgmt.apimanagement.models.``HostnameConfiguration`(*, type, host_name: str, key_vault_id: str = None, encoded_certificate: str = None, certificate_password: str = None, default_ssl_binding: bool = False, negotiate_client_certificate: bool = False, certificate=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Custom hostname configuration.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - type (str or HostnameType) – Required. Hostname type. Possible values include: ‘Proxy’, ‘Portal’, ‘Management’, ‘Scm’, ‘DeveloperPortal’
  - host_name (str) – Required. Hostname to configure on the Api Management service.
  - key_vault_id (str) – Url to the KeyVault Secret containing the Ssl Certificate. If absolute Url containing version is provided, auto-update of ssl certificate will not work. This requires Api Management service to be configured with MSI. The secret should be of type application/x-pkcs12
  - encoded_certificate (str) – Base64 Encoded certificate.
  - certificate_password (str) – Certificate Password.
  - default_ssl_binding (bool) – Specify true to setup the certificate associated with this Hostname as the Default SSL Certificate. If a client does not send the SNI header, then this will be the certificate that will be challenged. The property is useful if a service has multiple custom hostname enabled and it needs to decide on the default ssl certificate. The setting only applied to Proxy Hostname Type. Default value: False .
  - negotiate_client_certificate (bool) – Specify true to always negotiate client certificate on the hostname. Default Value is false. Default value: False .
  - certificate (CertificateInformation) – Certificate information.

class `azure.mgmt.apimanagement.models.``VirtualNetworkConfiguration`(*, subnet_resource_id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Configuration of a virtual network to which API Management service is deployed.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - vnetid (str) – The virtual network ID. This is typically a GUID. Expect a null GUID by default.
  - subnetname (str) – The name of the subnet.

  Parameters: | subnet_resource_id (str) – The full resource ID of a subnet in a virtual network to deploy the API Management service in.

class `azure.mgmt.apimanagement.models.``ApiManagementServiceSkuProperties`(*, name, capacity: int = None, **kwargs)

  Bases: `msrest.serialization.Model`

  API Management service resource SKU properties.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str or SkuType) – Required. Name of the Sku. Possible values include: ‘Developer’, ‘Standard’, ‘Premium’, ‘Basic’, ‘Consumption’
  - capacity (int) – Capacity of the SKU (number of deployed units of the SKU).

class `azure.mgmt.apimanagement.models.``AdditionalLocation`(*, location: str, sku, virtual_network_configuration=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Description of an additional API Management resource location.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - location (str) – Required. The location name of the additional region among Azure Data center regions.
  - sku (ApiManagementServiceSkuProperties) – Required. SKU properties of the API Management service.
  - virtual_network_configuration (VirtualNetworkConfiguration) – Virtual network configuration for the location.

  Variables:

  - public_ip_addresses (list[str]) – Public Static Load Balanced IP addresses of the API Management service in the additional location. Available only for Basic, Standard and Premium SKU.
  - private_ip_addresses (list[str]) – Private Static Load Balanced IP addresses of the API Management service which is deployed in an Internal Virtual Network in a particular additional location. Available only for Basic, Standard and Premium SKU.
  - gateway_regional_url (str) – Gateway URL of the API Management service in the Region.

class `azure.mgmt.apimanagement.models.``ApiManagementServiceBackupRestoreParameters`(*, storage_account: str, access_key: str, container_name: str, backup_name: str, **kwargs)

  Bases: `msrest.serialization.Model`

  Parameters supplied to the Backup/Restore of an API Management service operation.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - storage_account (str) – Required. Azure Cloud Storage account (used to place/retrieve the backup) name.
  - access_key (str) – Required. Azure Cloud Storage account (used to place/retrieve the backup) access key.
  - container_name (str) – Required. Azure Cloud Storage blob container name used to place/retrieve the backup.
  - backup_name (str) – Required. The name of the backup file to create.

class `azure.mgmt.apimanagement.models.``ApiManagementServiceBaseProperties`(*, notification_sender_email: str = None, hostname_configurations=None, virtual_network_configuration=None, additional_locations=None, custom_properties=None, certificates=None, enable_client_certificate: bool = False, virtual_network_type='None', **kwargs)

  Bases: `msrest.serialization.Model`

  Base Properties of an API Management service resource description.

  Variables are only populated by the server, and will be ignored when sending a request.

  Parameters:

  - notification_sender_email (str) – Email address from which the notification will be sent.
  - hostname_configurations (list[HostnameConfiguration]) – Custom hostname configuration of the API Management service.
  - virtual_network_configuration (VirtualNetworkConfiguration) – Virtual network configuration of the API Management service.
  - additional_locations (list[AdditionalLocation]) – Additional datacenter locations of the API Management service.
  - custom_properties (dict[str, str]) – Custom properties of the API Management service. Setting Microsoft.WindowsAzure.ApiManagement.Gateway.Security.Ciphers.TripleDes168 will disable the cipher TLS_RSA_WITH_3DES_EDE_CBC_SHA for all TLS(1.0, 1.1 and 1.2). Setting Microsoft.WindowsAzure.ApiManagement.Gateway.Security.Protocols.Tls11 can be used to disable just TLS 1.1 and setting Microsoft.WindowsAzure.ApiManagement.Gateway.Security.Protocols.Tls10 can be used to disable TLS 1.0 on an API Management service.
  - certificates (list[CertificateConfiguration]) – List of Certificates that need to be installed in the API Management service. Max supported certificates that can be installed is 10.
  - enable_client_certificate (bool) – Property only meant to be used for Consumption SKU Service. This enforces a client certificate to be presented on each request to the gateway. This also enables the ability to authenticate the certificate in the policy on the gateway. Default value: False .
  - virtual_network_type (str or VirtualNetworkType) – The type of VPN in which API Management service needs to be configured in. None (Default Value) means the API Management service is not part of any Virtual Network, External means the API Management deployment is set up inside a Virtual Network having an Internet Facing Endpoint, and Internal means that API Management deployment is setup inside a Virtual Network having an Intranet Facing Endpoint only. Possible values include: ‘None’, ‘External’, ‘Internal’. Default value: “None” .

  Variables:

  - provisioning_state (str) – The current provisioning state of the API Management service which can be one of the following: Created/Activating/Succeeded/Updating/Failed/Stopped/Terminating/TerminationFailed/Deleted.
  - target_provisioning_state (str) – The provisioning state of the API Management service, which is targeted by the long running operation started on the service.
  - created_at_utc (datetime) – Creation UTC date of the API Management service.The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.
  - gateway_url (str) – Gateway URL of the API Management service.
  - gateway_regional_url (str) – Gateway URL of the API Management service in the Default Region.
  - portal_url (str) – Publisher portal endpoint Url of the API Management service.
  - management_api_url (str) – Management API endpoint URL of the API Management service.
  - scm_url (str) – SCM endpoint URL of the API Management service.
  - public_ip_addresses (list[str]) – Public Static Load Balanced IP addresses of the API Management service in Primary region. Available only for Basic, Standard and Premium SKU.
  - private_ip_addresses (list[str]) – Private Static Load Balanced IP addresses of the API Management service in Primary region which is deployed in an Internal Virtual Network. Available only for Basic, Standard and Premium SKU.

class `azure.mgmt.apimanagement.models.``ApiManagementServiceIdentity`(**kwargs)

  Bases: `msrest.serialization.Model`

  Identity properties of the Api Management service resource.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - type (str) – Required. The identity type. Currently the only supported type is ‘SystemAssigned’. Default value: “SystemAssigned” .
  - principal_id (str) – The principal id of the identity.
  - tenant_id (str) – The client tenant id of the identity.

  `type` = 'SystemAssigned'

class `azure.mgmt.apimanagement.models.``ApiManagementServiceResource`(*, publisher_email: str, publisher_name: str, sku, location: str, tags=None, notification_sender_email: str = None, hostname_configurations=None, virtual_network_configuration=None, additional_locations=None, custom_properties=None, certificates=None, enable_client_certificate: bool = False, virtual_network_type='None', identity=None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.apim_resource_py3.ApimResource`

  A single API Management service resource in List or Get response.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource is set to Microsoft.ApiManagement.
  - provisioning_state (str) – The current provisioning state of the API Management service which can be one of the following: Created/Activating/Succeeded/Updating/Failed/Stopped/Terminating/TerminationFailed/Deleted.
  - target_provisioning_state (str) – The provisioning state of the API Management service, which is targeted by the long running operation started on the service.
  - created_at_utc (datetime) – Creation UTC date of the API Management service.The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.
  - gateway_url (str) – Gateway URL of the API Management service.
  - gateway_regional_url (str) – Gateway URL of the API Management service in the Default Region.
  - portal_url (str) – Publisher portal endpoint Url of the API Management service.
  - management_api_url (str) – Management API endpoint URL of the API Management service.
  - scm_url (str) – SCM endpoint URL of the API Management service.
  - public_ip_addresses (list[str]) – Public Static Load Balanced IP addresses of the API Management service in Primary region. Available only for Basic, Standard and Premium SKU.
  - private_ip_addresses (list[str]) – Private Static Load Balanced IP addresses of the API Management service in Primary region which is deployed in an Internal Virtual Network. Available only for Basic, Standard and Premium SKU.
  - etag (str) – ETag of the resource.

  Parameters:

  - tags (dict[str, str]) – Resource tags.
  - notification_sender_email (str) – Email address from which the notification will be sent.
  - hostname_configurations (list[HostnameConfiguration]) – Custom hostname configuration of the API Management service.
  - virtual_network_configuration (VirtualNetworkConfiguration) – Virtual network configuration of the API Management service.
  - additional_locations (list[AdditionalLocation]) – Additional datacenter locations of the API Management service.
  - custom_properties (dict[str, str]) – Custom properties of the API Management service. Setting Microsoft.WindowsAzure.ApiManagement.Gateway.Security.Ciphers.TripleDes168 will disable the cipher TLS_RSA_WITH_3DES_EDE_CBC_SHA for all TLS(1.0, 1.1 and 1.2). Setting Microsoft.WindowsAzure.ApiManagement.Gateway.Security.Protocols.Tls11 can be used to disable just TLS 1.1 and setting Microsoft.WindowsAzure.ApiManagement.Gateway.Security.Protocols.Tls10 can be used to disable TLS 1.0 on an API Management service.
  - certificates (list[CertificateConfiguration]) – List of Certificates that need to be installed in the API Management service. Max supported certificates that can be installed is 10.
  - enable_client_certificate (bool) – Property only meant to be used for Consumption SKU Service. This enforces a client certificate to be presented on each request to the gateway. This also enables the ability to authenticate the certificate in the policy on the gateway. Default value: False .
  - virtual_network_type (str or VirtualNetworkType) – The type of VPN in which API Management service needs to be configured in. None (Default Value) means the API Management service is not part of any Virtual Network, External means the API Management deployment is set up inside a Virtual Network having an Internet Facing Endpoint, and Internal means that API Management deployment is setup inside a Virtual Network having an Intranet Facing Endpoint only. Possible values include: ‘None’, ‘External’, ‘Internal’. Default value: “None” .
  - publisher_email (str) – Required. Publisher email.
  - publisher_name (str) – Required. Publisher name.
  - sku (ApiManagementServiceSkuProperties) – Required. SKU properties of the API Management service.
  - identity (ApiManagementServiceIdentity) – Managed service identity of the Api Management service.
  - location (str) – Required. Resource location.

class `azure.mgmt.apimanagement.models.``ApimResource`(*, tags=None, **kwargs)

  Bases: `msrest.serialization.Model`

  The Resource definition.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource is set to Microsoft.ApiManagement.

  Parameters: | tags (dict[str, str]) – Resource tags.

class `azure.mgmt.apimanagement.models.``ApiManagementServiceUpdateParameters`(*, tags=None, notification_sender_email: str = None, hostname_configurations=None, virtual_network_configuration=None, additional_locations=None, custom_properties=None, certificates=None, enable_client_certificate: bool = False, virtual_network_type='None', publisher_email: str = None, publisher_name: str = None, sku=None, identity=None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.apim_resource_py3.ApimResource`

  Parameter supplied to Update Api Management Service.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource is set to Microsoft.ApiManagement.
  - provisioning_state (str) – The current provisioning state of the API Management service which can be one of the following: Created/Activating/Succeeded/Updating/Failed/Stopped/Terminating/TerminationFailed/Deleted.
  - target_provisioning_state (str) – The provisioning state of the API Management service, which is targeted by the long running operation started on the service.
  - created_at_utc (datetime) – Creation UTC date of the API Management service.The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.
  - gateway_url (str) – Gateway URL of the API Management service.
  - gateway_regional_url (str) – Gateway URL of the API Management service in the Default Region.
  - portal_url (str) – Publisher portal endpoint Url of the API Management service.
  - management_api_url (str) – Management API endpoint URL of the API Management service.
  - scm_url (str) – SCM endpoint URL of the API Management service.
  - public_ip_addresses (list[str]) – Public Static Load Balanced IP addresses of the API Management service in Primary region. Available only for Basic, Standard and Premium SKU.
  - private_ip_addresses (list[str]) – Private Static Load Balanced IP addresses of the API Management service in Primary region which is deployed in an Internal Virtual Network. Available only for Basic, Standard and Premium SKU.
  - etag (str) – ETag of the resource.

  Parameters:

  - tags (dict[str, str]) – Resource tags.
  - notification_sender_email (str) – Email address from which the notification will be sent.
  - hostname_configurations (list[HostnameConfiguration]) – Custom hostname configuration of the API Management service.
  - virtual_network_configuration (VirtualNetworkConfiguration) – Virtual network configuration of the API Management service.
  - additional_locations (list[AdditionalLocation]) – Additional datacenter locations of the API Management service.
  - custom_properties (dict[str, str]) – Custom properties of the API Management service. Setting Microsoft.WindowsAzure.ApiManagement.Gateway.Security.Ciphers.TripleDes168 will disable the cipher TLS_RSA_WITH_3DES_EDE_CBC_SHA for all TLS(1.0, 1.1 and 1.2). Setting Microsoft.WindowsAzure.ApiManagement.Gateway.Security.Protocols.Tls11 can be used to disable just TLS 1.1 and setting Microsoft.WindowsAzure.ApiManagement.Gateway.Security.Protocols.Tls10 can be used to disable TLS 1.0 on an API Management service.
  - certificates (list[CertificateConfiguration]) – List of Certificates that need to be installed in the API Management service. Max supported certificates that can be installed is 10.
  - enable_client_certificate (bool) – Property only meant to be used for Consumption SKU Service. This enforces a client certificate to be presented on each request to the gateway. This also enables the ability to authenticate the certificate in the policy on the gateway. Default value: False .
  - virtual_network_type (str or VirtualNetworkType) – The type of VPN in which API Management service needs to be configured in. None (Default Value) means the API Management service is not part of any Virtual Network, External means the API Management deployment is set up inside a Virtual Network having an Internet Facing Endpoint, and Internal means that API Management deployment is setup inside a Virtual Network having an Intranet Facing Endpoint only. Possible values include: ‘None’, ‘External’, ‘Internal’. Default value: “None” .
  - publisher_email (str) – Publisher email.
  - publisher_name (str) – Publisher name.
  - sku (ApiManagementServiceSkuProperties) – SKU properties of the API Management service.
  - identity (ApiManagementServiceIdentity) – Managed service identity of the Api Management service.

class `azure.mgmt.apimanagement.models.``ApiManagementServiceGetSsoTokenResult`(*, redirect_uri: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  The response of the GetSsoToken operation.

  Parameters: | redirect_uri (str) – Redirect URL to the Publisher Portal containing the SSO token.

class `azure.mgmt.apimanagement.models.``ApiManagementServiceCheckNameAvailabilityParameters`(*, name: str, **kwargs)

  Bases: `msrest.serialization.Model`

  Parameters supplied to the CheckNameAvailability operation.

  All required parameters must be populated in order to send to Azure.

  Parameters: | name (str) – Required. The name to check for availability.

class `azure.mgmt.apimanagement.models.``ApiManagementServiceNameAvailabilityResult`(*, reason=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Response of the CheckNameAvailability operation.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - name_available (bool) – True if the name is available and can be used to create a new API Management service; otherwise false.
  - message (str) – If reason == invalid, provide the user with the reason why the given name is invalid, and provide the resource naming requirements so that the user can select a valid name. If reason == AlreadyExists, explain that <resourceName> is already in use, and direct them to select a different name.

  Parameters: | reason (str or NameAvailabilityReason) – Invalid indicates the name provided does not match the resource provider’s naming requirements (incorrect length, unsupported characters, etc.) AlreadyExists indicates that the name is already in use and is therefore unavailable. Possible values include: ‘Valid’, ‘Invalid’, ‘AlreadyExists’

class `azure.mgmt.apimanagement.models.``ApiManagementServiceApplyNetworkConfigurationParameters`(*, location: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Parameter supplied to the Apply Network configuration operation.

  Parameters: | location (str) – Location of the Api Management service to update for a multi-region service. For a service deployed in a single region, this parameter is not required.

class `azure.mgmt.apimanagement.models.``OperationDisplay`(*, provider: str = None, operation: str = None, resource: str = None, description: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  The object that describes the operation.

  Parameters:

  - provider (str) – Friendly name of the resource provider
  - operation (str) – Operation type: read, write, delete, listKeys/action, etc.
  - resource (str) – Resource type on which the operation is performed.
  - description (str) – Friendly name of the operation

class `azure.mgmt.apimanagement.models.``Operation`(*, name: str = None, display=None, origin: str = None, properties=None, **kwargs)

  Bases: `msrest.serialization.Model`

  REST API operation.

  Parameters:

  - name (str) – Operation name: {provider}/{resource}/{operation}
  - display (OperationDisplay) – The object that describes the operation.
  - origin (str) – The operation origin.
  - properties (object) – The operation properties.

class `azure.mgmt.apimanagement.models.``EmailTemplateParametersContractProperties`(*, name: str = None, title: str = None, description: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Email Template Parameter contract.

  Parameters:

  - name (str) – Template parameter name.
  - title (str) – Template parameter title.
  - description (str) – Template parameter description.

class `azure.mgmt.apimanagement.models.``EmailTemplateUpdateParameters`(*, subject: str = None, title: str = None, description: str = None, body: str = None, parameters=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Email Template update Parameters.

  Parameters:

  - subject (str) – Subject of the Template.
  - title (str) – Title of the Template.
  - description (str) – Description of the Email Template.
  - body (str) – Email Template Body. This should be a valid XDocument
  - parameters (list[EmailTemplateParametersContractProperties]) – Email Template Parameter values.

class `azure.mgmt.apimanagement.models.``EmailTemplateContract`(*, subject: str, body: str, title: str = None, description: str = None, parameters=None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Email Template details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.
  - is_default (bool) – Whether the template is the default template provided by Api Management or has been edited.

  Parameters:

  - subject (str) – Required. Subject of the Template.
  - body (str) – Required. Email Template Body. This should be a valid XDocument
  - title (str) – Title of the Template.
  - description (str) – Description of the Email Template.
  - parameters (list[EmailTemplateParametersContractProperties]) – Email Template Parameter values.

class `azure.mgmt.apimanagement.models.``UserIdentityContract`(*, provider: str = None, id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  User identity details.

  Parameters:

  - provider (str) – Identity provider name.
  - id (str) – Identifier value within provider.

class `azure.mgmt.apimanagement.models.``UserEntityBaseParameters`(*, state='active', note: str = None, identities=None, **kwargs)

  Bases: `msrest.serialization.Model`

  User Entity Base Parameters set.

  Parameters:

  - state (str or UserState) – Account state. Specifies whether the user is active or not. Blocked users are unable to sign into the developer portal or call any APIs of subscribed products. Default state is Active. Possible values include: ‘active’, ‘blocked’, ‘pending’, ‘deleted’. Default value: “active” .
  - note (str) – Optional note about a user set by the administrator.
  - identities (list[UserIdentityContract]) – Collection of user identities.

class `azure.mgmt.apimanagement.models.``GroupContractProperties`(*, display_name: str, description: str = None, type=None, external_id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Group contract Properties.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - display_name (str) – Required. Group name.
  - description (str) – Group description. Can contain HTML formatting tags.
  - type (str or GroupType) – Group type. Possible values include: ‘custom’, ‘system’, ‘external’
  - external_id (str) – For external groups, this property contains the id of the group from the external identity provider, e.g. for Azure Active Directory aad://<tenant>.onmicrosoft.com/groups/<group object id>; otherwise the value is null.

  Variables: | built_in (bool) – true if the group is one of the three system groups (Administrators, Developers, or Guests); otherwise false.

class `azure.mgmt.apimanagement.models.``UserContract`(*, state='active', note: str = None, identities=None, first_name: str = None, last_name: str = None, email: str = None, registration_date=None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  User details.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.
  - groups (list[GroupContractProperties]) – Collection of groups user is part of.

  Parameters:

  - state (str or UserState) – Account state. Specifies whether the user is active or not. Blocked users are unable to sign into the developer portal or call any APIs of subscribed products. Default state is Active. Possible values include: ‘active’, ‘blocked’, ‘pending’, ‘deleted’. Default value: “active” .
  - note (str) – Optional note about a user set by the administrator.
  - identities (list[UserIdentityContract]) – Collection of user identities.
  - first_name (str) – First name.
  - last_name (str) – Last name.
  - email (str) – Email address.
  - registration_date (datetime) – Date of user registration. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.

class `azure.mgmt.apimanagement.models.``GroupUpdateParameters`(*, display_name: str = None, description: str = None, type=None, external_id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Parameters supplied to the Update Group operation.

  Parameters:

  - display_name (str) – Group name.
  - description (str) – Group description.
  - type (str or GroupType) – Group type. Possible values include: ‘custom’, ‘system’, ‘external’
  - external_id (str) – Identifier of the external groups, this property contains the id of the group from the external identity provider, e.g. for Azure Active Directory aad://<tenant>.onmicrosoft.com/groups/<group object id>; otherwise the value is null.

class `azure.mgmt.apimanagement.models.``GroupContract`(*, display_name: str, description: str = None, group_contract_type=None, external_id: str = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Contract details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.
  - built_in (bool) – true if the group is one of the three system groups (Administrators, Developers, or Guests); otherwise false.

  Parameters:

  - display_name (str) – Required. Group name.
  - description (str) – Group description. Can contain HTML formatting tags.
  - group_contract_type (str or GroupType) – Group type. Possible values include: ‘custom’, ‘system’, ‘external’
  - external_id (str) – For external groups, this property contains the id of the group from the external identity provider, e.g. for Azure Active Directory aad://<tenant>.onmicrosoft.com/groups/<group object id>; otherwise the value is null.

class `azure.mgmt.apimanagement.models.``GroupCreateParameters`(*, display_name: str, description: str = None, type=None, external_id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Parameters supplied to the Create Group operation.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - display_name (str) – Required. Group name.
  - description (str) – Group description.
  - type (str or GroupType) – Group type. Possible values include: ‘custom’, ‘system’, ‘external’
  - external_id (str) – Identifier of the external groups, this property contains the id of the group from the external identity provider, e.g. for Azure Active Directory aad://<tenant>.onmicrosoft.com/groups/<group object id>; otherwise the value is null.

class `azure.mgmt.apimanagement.models.``IdentityProviderBaseParameters`(*, type=None, allowed_tenants=None, authority: str = None, signup_policy_name: str = None, signin_policy_name: str = None, profile_editing_policy_name: str = None, password_reset_policy_name: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Identity Provider Base Parameter Properties.

  Parameters:

  - type (str or IdentityProviderType) – Identity Provider Type identifier. Possible values include: ‘facebook’, ‘google’, ‘microsoft’, ‘twitter’, ‘aad’, ‘aadB2C’
  - allowed_tenants (list[str]) – List of Allowed Tenants when configuring Azure Active Directory login.
  - authority (str) – OpenID Connect discovery endpoint hostname for AAD or AAD B2C.
  - signup_policy_name (str) – Signup Policy Name. Only applies to AAD B2C Identity Provider.
  - signin_policy_name (str) – Signin Policy Name. Only applies to AAD B2C Identity Provider.
  - profile_editing_policy_name (str) – Profile Editing Policy Name. Only applies to AAD B2C Identity Provider.
  - password_reset_policy_name (str) – Password Reset Policy Name. Only applies to AAD B2C Identity Provider.

class `azure.mgmt.apimanagement.models.``IdentityProviderUpdateParameters`(*, type=None, allowed_tenants=None, authority: str = None, signup_policy_name: str = None, signin_policy_name: str = None, profile_editing_policy_name: str = None, password_reset_policy_name: str = None, client_id: str = None, client_secret: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Parameters supplied to update Identity Provider.

  Parameters:

  - type (str or IdentityProviderType) – Identity Provider Type identifier. Possible values include: ‘facebook’, ‘google’, ‘microsoft’, ‘twitter’, ‘aad’, ‘aadB2C’
  - allowed_tenants (list[str]) – List of Allowed Tenants when configuring Azure Active Directory login.
  - authority (str) – OpenID Connect discovery endpoint hostname for AAD or AAD B2C.
  - signup_policy_name (str) – Signup Policy Name. Only applies to AAD B2C Identity Provider.
  - signin_policy_name (str) – Signin Policy Name. Only applies to AAD B2C Identity Provider.
  - profile_editing_policy_name (str) – Profile Editing Policy Name. Only applies to AAD B2C Identity Provider.
  - password_reset_policy_name (str) – Password Reset Policy Name. Only applies to AAD B2C Identity Provider.
  - client_id (str) – Client Id of the Application in the external Identity Provider. It is App ID for Facebook login, Client ID for Google login, App ID for Microsoft.
  - client_secret (str) – Client secret of the Application in external Identity Provider, used to authenticate login request. For example, it is App Secret for Facebook login, API Key for Google login, Public Key for Microsoft.

class `azure.mgmt.apimanagement.models.``IdentityProviderContract`(*, client_id: str, client_secret: str, identity_provider_contract_type=None, allowed_tenants=None, authority: str = None, signup_policy_name: str = None, signin_policy_name: str = None, profile_editing_policy_name: str = None, password_reset_policy_name: str = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Identity Provider details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - identity_provider_contract_type (str or IdentityProviderType) – Identity Provider Type identifier. Possible values include: ‘facebook’, ‘google’, ‘microsoft’, ‘twitter’, ‘aad’, ‘aadB2C’
  - allowed_tenants (list[str]) – List of Allowed Tenants when configuring Azure Active Directory login.
  - authority (str) – OpenID Connect discovery endpoint hostname for AAD or AAD B2C.
  - signup_policy_name (str) – Signup Policy Name. Only applies to AAD B2C Identity Provider.
  - signin_policy_name (str) – Signin Policy Name. Only applies to AAD B2C Identity Provider.
  - profile_editing_policy_name (str) – Profile Editing Policy Name. Only applies to AAD B2C Identity Provider.
  - password_reset_policy_name (str) – Password Reset Policy Name. Only applies to AAD B2C Identity Provider.
  - client_id (str) – Required. Client Id of the Application in the external Identity Provider. It is App ID for Facebook login, Client ID for Google login, App ID for Microsoft.
  - client_secret (str) – Required. Client secret of the Application in external Identity Provider, used to authenticate login request. For example, it is App Secret for Facebook login, API Key for Google login, Public Key for Microsoft.

class `azure.mgmt.apimanagement.models.``LoggerUpdateContract`(*, logger_type=None, description: str = None, credentials=None, is_buffered: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Logger update contract.

  Parameters:

  - logger_type (str or LoggerType) – Logger type. Possible values include: ‘azureEventHub’, ‘applicationInsights’
  - description (str) – Logger description.
  - credentials (dict[str, str]) – Logger credentials.
  - is_buffered (bool) – Whether records are buffered in the logger before publishing. Default is assumed to be true.

class `azure.mgmt.apimanagement.models.``LoggerContract`(*, logger_type, credentials, description: str = None, is_buffered: bool = None, resource_id: str = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Logger details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - logger_type (str or LoggerType) – Required. Logger type. Possible values include: ‘azureEventHub’, ‘applicationInsights’
  - description (str) – Logger description.
  - credentials (dict[str, str]) – Required. The name and SendRule connection string of the event hub for azureEventHub logger. Instrumentation key for applicationInsights logger.
  - is_buffered (bool) – Whether records are buffered in the logger before publishing. Default is assumed to be true.
  - resource_id (str) – Azure Resource Id of a log target (either Azure Event Hub resource or Azure Application Insights resource).

class `azure.mgmt.apimanagement.models.``ConnectivityStatusContract`(*, name: str, status, last_updated, last_status_change, error: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Details about connectivity to a resource.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. The hostname of the resource which the service depends on. This can be the database, storage or any other azure resource on which the service depends upon.
  - status (str or ConnectivityStatusType) – Required. Resource Connectivity Status Type identifier. Possible values include: ‘initializing’, ‘success’, ‘failure’
  - error (str) – Error details of the connectivity to the resource.
  - last_updated (datetime) – Required. The date when the resource connectivity status was last updated. This status should be updated every 15 minutes. If this status has not been updated, then it means that the service has lost network connectivity to the resource, from inside the Virtual Network.The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.
  - last_status_change (datetime) – Required. The date when the resource connectivity status last Changed from success to failure or vice-versa. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.

class `azure.mgmt.apimanagement.models.``NetworkStatusContract`(*, dns_servers, connectivity_status, **kwargs)

  Bases: `msrest.serialization.Model`

  Network Status details.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - dns_servers (list[str]) – Required. Gets the list of DNS servers IPV4 addresses.
  - connectivity_status (list[ConnectivityStatusContract]) – Required. Gets the list of Connectivity Status to the Resources on which the service depends upon.

class `azure.mgmt.apimanagement.models.``NetworkStatusContractByLocation`(*, location: str = None, network_status=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Network Status in the Location.

  Parameters:

  - location (str) – Location of service
  - network_status (NetworkStatusContract) – Network status in Location

class `azure.mgmt.apimanagement.models.``RecipientEmailContract`(*, email: str = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Recipient Email details.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters: | email (str) – User Email subscribed to notification.

class `azure.mgmt.apimanagement.models.``RecipientEmailCollection`(*, value=None, next_link: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Paged Recipient User list representation.

  Parameters:

  - value (list[RecipientEmailContract]) – Page values.
  - next_link (str) – Next page link if any.

class `azure.mgmt.apimanagement.models.``RecipientUserContract`(*, user_id: str = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Recipient User details.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters: | user_id (str) – API Management UserId subscribed to notification.

class `azure.mgmt.apimanagement.models.``RecipientUserCollection`(*, value=None, next_link: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Paged Recipient User list representation.

  Parameters:

  - value (list[RecipientUserContract]) – Page values.
  - next_link (str) – Next page link if any.

class `azure.mgmt.apimanagement.models.``RecipientsContractProperties`(*, emails=None, users=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Notification Parameter contract.

  Parameters:

  - emails (list[str]) – List of Emails subscribed for the notification.
  - users (list[str]) – List of Users subscribed for the notification.

class `azure.mgmt.apimanagement.models.``NotificationContract`(*, title: str, description: str = None, recipients=None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Notification details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - title (str) – Required. Title of the Notification.
  - description (str) – Description of the Notification.
  - recipients (RecipientsContractProperties) – Recipient Parameter values.

class `azure.mgmt.apimanagement.models.``OpenidConnectProviderUpdateContract`(*, display_name: str = None, description: str = None, metadata_endpoint: str = None, client_id: str = None, client_secret: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Parameters supplied to the Update OpenID Connect Provider operation.

  Parameters:

  - display_name (str) – User-friendly OpenID Connect Provider name.
  - description (str) – User-friendly description of OpenID Connect Provider.
  - metadata_endpoint (str) – Metadata endpoint URI.
  - client_id (str) – Client ID of developer console which is the client application.
  - client_secret (str) – Client Secret of developer console which is the client application.

class `azure.mgmt.apimanagement.models.``OpenidConnectProviderContract`(*, display_name: str, metadata_endpoint: str, client_id: str, description: str = None, client_secret: str = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  OpenId Connect Provider details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - display_name (str) – Required. User-friendly OpenID Connect Provider name.
  - description (str) – User-friendly description of OpenID Connect Provider.
  - metadata_endpoint (str) – Required. Metadata endpoint URI.
  - client_id (str) – Required. Client ID of developer console which is the client application.
  - client_secret (str) – Client Secret of developer console which is the client application.

class `azure.mgmt.apimanagement.models.``PolicySnippetContract`(**kwargs)

  Bases: `msrest.serialization.Model`

  Policy snippet.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - name (str) – Snippet name.
  - content (str) – Snippet content.
  - tool_tip (str) – Snippet toolTip.
  - scope (int) – Binary OR value of the Snippet scope.

class `azure.mgmt.apimanagement.models.``PolicySnippetsCollection`(*, value=None, **kwargs)

  Bases: `msrest.serialization.Model`

  The response of the list policy snippets operation.

  Parameters: | value (list[PolicySnippetContract]) – Policy snippet value.

class `azure.mgmt.apimanagement.models.``RegistrationDelegationSettingsProperties`(*, enabled: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  User registration delegation settings properties.

  Parameters: | enabled (bool) – Enable or disable delegation for user registration.

class `azure.mgmt.apimanagement.models.``SubscriptionsDelegationSettingsProperties`(*, enabled: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Subscriptions delegation settings properties.

  Parameters: | enabled (bool) – Enable or disable delegation for subscriptions.

class `azure.mgmt.apimanagement.models.``PortalDelegationSettings`(*, url: str = None, validation_key: str = None, subscriptions=None, user_registration=None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Delegation settings for a developer portal.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - url (str) – A delegation Url.
  - validation_key (str) – A base64-encoded validation key to validate, that a request is coming from Azure API Management.
  - subscriptions (SubscriptionsDelegationSettingsProperties) – Subscriptions delegation settings.
  - user_registration (RegistrationDelegationSettingsProperties) – User registration delegation settings.

class `azure.mgmt.apimanagement.models.``TermsOfServiceProperties`(*, text: str = None, enabled: bool = None, consent_required: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Terms of service contract properties.

  Parameters:

  - text (str) – A terms of service text.
  - enabled (bool) – Display terms of service during a sign-up process.
  - consent_required (bool) – Ask user for consent to the terms of service.

class `azure.mgmt.apimanagement.models.``PortalSignupSettings`(*, enabled: bool = None, terms_of_service=None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Sign-Up settings for a developer portal.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - enabled (bool) – Allow users to sign up on a developer portal.
  - terms_of_service (TermsOfServiceProperties) – Terms of service contract properties.

class `azure.mgmt.apimanagement.models.``PortalSigninSettings`(*, enabled: bool = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Sign-In settings for the Developer Portal.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters: | enabled (bool) – Redirect Anonymous users to the Sign-In page.

class `azure.mgmt.apimanagement.models.``SubscriptionContract`(*, scope: str, state, primary_key: str, secondary_key: str, owner_id: str = None, display_name: str = None, start_date=None, expiration_date=None, end_date=None, notification_date=None, state_comment: str = None, allow_tracing: bool = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Subscription details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.
  - created_date (datetime) – Subscription creation date. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.

  Parameters:

  - owner_id (str) – The user resource identifier of the subscription owner. The value is a valid relative URL in the format of /users/{userId} where {userId} is a user identifier.
  - scope (str) – Required. Scope like /products/{productId} or /apis or /apis/{apiId}.
  - display_name (str) – The name of the subscription, or null if the subscription has no name.
  - state (str or SubscriptionState) – Required. Subscription state. Possible states are * active – the subscription is active, * suspended – the subscription is blocked, and the subscriber cannot call any APIs of the product, * submitted – the subscription request has been made by the developer, but has not yet been approved or rejected, * rejected – the subscription request has been denied by an administrator, * cancelled – the subscription has been cancelled by the developer or administrator, * expired – the subscription reached its expiration date and was deactivated. Possible values include: ‘suspended’, ‘active’, ‘expired’, ‘submitted’, ‘rejected’, ‘cancelled’
  - start_date (datetime) – Subscription activation date. The setting is for audit purposes only and the subscription is not automatically activated. The subscription lifecycle can be managed by using the state property. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.
  - expiration_date (datetime) – Subscription expiration date. The setting is for audit purposes only and the subscription is not automatically expired. The subscription lifecycle can be managed by using the state property. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.
  - end_date (datetime) – Date when subscription was cancelled or expired. The setting is for audit purposes only and the subscription is not automatically cancelled. The subscription lifecycle can be managed by using the state property. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.
  - notification_date (datetime) – Upcoming subscription expiration notification date. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.
  - primary_key (str) – Required. Subscription primary key.
  - secondary_key (str) – Required. Subscription secondary key.
  - state_comment (str) – Optional subscription comment added by an administrator.
  - allow_tracing (bool) – Determines whether tracing is enabled

class `azure.mgmt.apimanagement.models.``ProductUpdateParameters`(*, description: str = None, terms: str = None, subscription_required: bool = None, approval_required: bool = None, subscriptions_limit: int = None, state=None, display_name: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Product Update parameters.

  Parameters:

  - description (str) – Product description. May include HTML formatting tags.
  - terms (str) – Product terms of use. Developers trying to subscribe to the product will be presented and required to accept these terms before they can complete the subscription process.
  - subscription_required (bool) – Whether a product subscription is required for accessing APIs included in this product. If true, the product is referred to as “protected” and a valid subscription key is required for a request to an API included in the product to succeed. If false, the product is referred to as “open” and requests to an API included in the product can be made without a subscription key. If property is omitted when creating a new product it’s value is assumed to be true.
  - approval_required (bool) – whether subscription approval is required. If false, new subscriptions will be approved automatically enabling developers to call the product’s APIs immediately after subscribing. If true, administrators must manually approve the subscription before the developer can any of the product’s APIs. Can be present only if subscriptionRequired property is present and has a value of false.
  - subscriptions_limit (int) – Whether the number of subscriptions a user can have to this product at the same time. Set to null or omit to allow unlimited per user subscriptions. Can be present only if subscriptionRequired property is present and has a value of false.
  - state (str or ProductState) – whether product is published or not. Published products are discoverable by users of developer portal. Non published products are visible only to administrators. Default state of Product is notPublished. Possible values include: ‘notPublished’, ‘published’
  - display_name (str) – Product name.

class `azure.mgmt.apimanagement.models.``PropertyEntityBaseParameters`(*, tags=None, secret: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Property Entity Base Parameters set.

  Parameters:

  - tags (list[str]) – Optional tags that when provided can be used to filter the property list.
  - secret (bool) – Determines whether the value is a secret and should be encrypted or not. Default value is false.

class `azure.mgmt.apimanagement.models.``PropertyUpdateParameters`(*, tags=None, secret: bool = None, display_name: str = None, value: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Property update Parameters.

  Parameters:

  - tags (list[str]) – Optional tags that when provided can be used to filter the property list.
  - secret (bool) – Determines whether the value is a secret and should be encrypted or not. Default value is false.
  - display_name (str) – Unique name of Property. It may contain only letters, digits, period, dash, and underscore characters.
  - value (str) – Value of the property. Can contain policy expressions. It may not be empty or consist only of whitespace.

class `azure.mgmt.apimanagement.models.``PropertyContract`(*, display_name: str, value: str, tags=None, secret: bool = None, **kwargs)

  Bases: `azure.mgmt.apimanagement.models.resource_py3.Resource`

  Property details.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type for API Management resource.

  Parameters:

  - tags (list[str]) – Optional tags that when provided can be used to filter the property list.
  - secret (bool) – Determines whether the value is a secret and should be encrypted or not. Default value is false.
  - display_name (str) – Required. Unique name of Property. It may contain only letters, digits, period, dash, and underscore characters.
  - value (str) – Required. Value of the property. Can contain policy expressions. It may not be empty or consist only of whitespace.

class `azure.mgmt.apimanagement.models.``QuotaCounterValueContractProperties`(*, calls_count: int = None, kb_transferred: float = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Quota counter value details.

  Parameters:

  - calls_count (int) – Number of times Counter was called.
  - kb_transferred (float) – Data Transferred in KiloBytes.

class `azure.mgmt.apimanagement.models.``QuotaCounterContract`(*, counter_key: str, period_key: str, period_start_time, period_end_time, value=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Quota counter details.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - counter_key (str) – Required. The Key value of the Counter. Must not be empty.
  - period_key (str) – Required. Identifier of the Period for which the counter was collected. Must not be empty.
  - period_start_time (datetime) – Required. The date of the start of Counter Period. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.
  - period_end_time (datetime) – Required. The date of the end of Counter Period. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.
  - value (QuotaCounterValueContractProperties) – Quota Value Properties

class `azure.mgmt.apimanagement.models.``QuotaCounterCollection`(*, value=None, count: int = None, next_link: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Paged Quota Counter list representation.

  Parameters:

  - value (list[QuotaCounterContract]) – Quota counter values.
  - count (long) – Total record count number across all pages.
  - next_link (str) – Next page link if any.

class `azure.mgmt.apimanagement.models.``RequestReportRecordContract`(*, api_id: str = None, operation_id: str = None, method: str = None, url: str = None, ip_address: str = None, backend_response_code: str = None, response_code: int = None, response_size: int = None, timestamp=None, cache: str = None, api_time: float = None, service_time: float = None, api_region: str = None, subscription_id: str = None, request_id: str = None, request_size: int = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Request Report data.

  Variables are only populated by the server, and will be ignored when sending a request.

  Parameters:

  - api_id (str) – API identifier path. /apis/{apiId}
  - operation_id (str) – Operation identifier path. /apis/{apiId}/operations/{operationId}
  - method (str) – The HTTP method associated with this request..
  - url (str) – The full URL associated with this request.
  - ip_address (str) – The client IP address associated with this request.
  - backend_response_code (str) – The HTTP status code received by the gateway as a result of forwarding this request to the backend.
  - response_code (int) – The HTTP status code returned by the gateway.
  - response_size (int) – The size of the response returned by the gateway.
  - timestamp (datetime) – The date and time when this request was received by the gateway in ISO 8601 format.
  - cache (str) – Specifies if response cache was involved in generating the response. If the value is none, the cache was not used. If the value is hit, cached response was returned. If the value is miss, the cache was used but lookup resulted in a miss and request was fulfilled by the backend.
  - api_time (float) – The total time it took to process this request.
  - service_time (float) – he time it took to forward this request to the backend and get the response back.
  - api_region (str) – Azure region where the gateway that processed this request is located.
  - subscription_id (str) – Subscription identifier path. /subscriptions/{subscriptionId}
  - request_id (str) – Request Identifier.
  - request_size (int) – The size of this request..

  Variables:

  - product_id (str) – Product identifier path. /products/{productId}
  - user_id (str) – User identifier path. /users/{userId}

class `azure.mgmt.apimanagement.models.``ReportRecordContract`(*, name: str = None, timestamp=None, interval: str = None, country: str = None, region: str = None, zip: str = None, api_id: str = None, operation_id: str = None, api_region: str = None, subscription_id: str = None, call_count_success: int = None, call_count_blocked: int = None, call_count_failed: int = None, call_count_other: int = None, call_count_total: int = None, bandwidth: int = None, cache_hit_count: int = None, cache_miss_count: int = None, api_time_avg: float = None, api_time_min: float = None, api_time_max: float = None, service_time_avg: float = None, service_time_min: float = None, service_time_max: float = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Report data.

  Variables are only populated by the server, and will be ignored when sending a request.

  Parameters:

  - name (str) – Name depending on report endpoint specifies product, API, operation or developer name.
  - timestamp (datetime) – Start of aggregation period. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.
  - interval (str) – Length of aggregation period. Interval must be multiple of 15 minutes and may not be zero. The value should be in ISO 8601 format (http://en.wikipedia.org/wiki/ISO_8601#Durations).
  - country (str) – Country to which this record data is related.
  - region (str) – Country region to which this record data is related.
  - zip (str) – Zip code to which this record data is related.
  - api_id (str) – API identifier path. /apis/{apiId}
  - operation_id (str) – Operation identifier path. /apis/{apiId}/operations/{operationId}
  - api_region (str) – API region identifier.
  - subscription_id (str) – Subscription identifier path. /subscriptions/{subscriptionId}
  - call_count_success (int) – Number of successful calls. This includes calls returning HttpStatusCode <= 301 and HttpStatusCode.NotModified and HttpStatusCode.TemporaryRedirect
  - call_count_blocked (int) – Number of calls blocked due to invalid credentials. This includes calls returning HttpStatusCode.Unauthorized and HttpStatusCode.Forbidden and HttpStatusCode.TooManyRequests
  - call_count_failed (int) – Number of calls failed due to proxy or backend errors. This includes calls returning HttpStatusCode.BadRequest(400) and any Code between HttpStatusCode.InternalServerError (500) and 600
  - call_count_other (int) – Number of other calls.
  - call_count_total (int) – Total number of calls.
  - bandwidth (long) – Bandwidth consumed.
  - cache_hit_count (int) – Number of times when content was served from cache policy.
  - cache_miss_count (int) – Number of times content was fetched from backend.
  - api_time_avg (float) – Average time it took to process request.
  - api_time_min (float) – Minimum time it took to process request.
  - api_time_max (float) – Maximum time it took to process request.
  - service_time_avg (float) – Average time it took to process request on backend.
  - service_time_min (float) – Minimum time it took to process request on backend.
  - service_time_max (float) – Maximum time it took to process request on backend.

  Variables:

  - user_id (str) – User identifier path. /users/{userId}
  - product_id (str) – Product identifier path. /products/{productId}

class `azure.mgmt.apimanagement.models.``SubscriptionUpdateParameters`(*, owner_id: str = None, scope: str = None, expiration_date=None, display_name: str = None, primary_key: str = None, secondary_key: str = None, state=None, state_comment: str = None, allow_tracing: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Subscription update details.

  Parameters:

  - owner_id (str) – User identifier path: /users/{userId}
  - scope (str) – Scope like /products/{productId} or /apis or /apis/{apiId}
  - expiration_date (datetime) – Subscription expiration date. The setting is for audit purposes only and the subscription is not automatically expired. The subscription lifecycle can be managed by using the state property. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.
  - display_name (str) – Subscription name.
  - primary_key (str) – Primary subscription key.
  - secondary_key (str) – Secondary subscription key.
  - state (str or SubscriptionState) – Subscription state. Possible states are * active – the subscription is active, * suspended – the subscription is blocked, and the subscriber cannot call any APIs of the product, * submitted – the subscription request has been made by the developer, but has not yet been approved or rejected, * rejected – the subscription request has been denied by an administrator, * cancelled – the subscription has been cancelled by the developer or administrator, * expired – the subscription reached its expiration date and was deactivated. Possible values include: ‘suspended’, ‘active’, ‘expired’, ‘submitted’, ‘rejected’, ‘cancelled’
  - state_comment (str) – Comments describing subscription state change by the administrator.
  - allow_tracing (bool) – Determines whether tracing can be enabled

class `azure.mgmt.apimanagement.models.``SubscriptionCreateParameters`(*, scope: str, display_name: str, owner_id: str = None, primary_key: str = None, secondary_key: str = None, state=None, allow_tracing: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Subscription create details.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - owner_id (str) – User (user id path) for whom subscription is being created in form /users/{userId}
  - scope (str) – Required. Scope like /products/{productId} or /apis or /apis/{apiId}.
  - display_name (str) – Required. Subscription name.
  - primary_key (str) – Primary subscription key. If not specified during request key will be generated automatically.
  - secondary_key (str) – Secondary subscription key. If not specified during request key will be generated automatically.
  - state (str or SubscriptionState) – Initial subscription state. If no value is specified, subscription is created with Submitted state. Possible states are * active – the subscription is active, * suspended – the subscription is blocked, and the subscriber cannot call any APIs of the product, * submitted – the subscription request has been made by the developer, but has not yet been approved or rejected, * rejected – the subscription request has been denied by an administrator, * cancelled – the subscription has been cancelled by the developer or administrator, * expired – the subscription reached its expiration date and was deactivated. Possible values include: ‘suspended’, ‘active’, ‘expired’, ‘submitted’, ‘rejected’, ‘cancelled’
  - allow_tracing (bool) – Determines whether tracing can be enabled

class `azure.mgmt.apimanagement.models.``TagCreateUpdateParameters`(*, display_name: str, **kwargs)

  Bases: `msrest.serialization.Model`

  Parameters supplied to Create/Update Tag operations.

  All required parameters must be populated in order to send to Azure.

  Parameters: | display_name (str) – Required. Tag name.

class `azure.mgmt.apimanagement.models.``TenantConfigurationSyncStateContract`(*, branch: str = None, commit_id: str = None, is_export: bool = None, is_synced: bool = None, is_git_enabled: bool = None, sync_date=None, configuration_change_date=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Tenant Configuration Synchronization State.

  Parameters:

  - branch (str) – The name of Git branch.
  - commit_id (str) – The latest commit Id.
  - is_export (bool) – value indicating if last sync was save (true) or deploy (false) operation.
  - is_synced (bool) – value indicating if last synchronization was later than the configuration change.
  - is_git_enabled (bool) – value indicating whether Git configuration access is enabled.
  - sync_date (datetime) – The date of the latest synchronization. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.
  - configuration_change_date (datetime) – The date of the latest configuration change. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.

class `azure.mgmt.apimanagement.models.``OperationResultLogItemContract`(*, object_type: str = None, action: str = None, object_key: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Log of the entity being created, updated or deleted.

  Parameters:

  - object_type (str) – The type of entity contract.
  - action (str) – Action like create/update/delete.
  - object_key (str) – Identifier of the entity being created/updated/deleted.

class `azure.mgmt.apimanagement.models.``OperationResultContract`(*, id: str = None, status=None, started=None, updated=None, result_info: str = None, error=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Operation Result.

  Variables are only populated by the server, and will be ignored when sending a request.

  Parameters:

  - id (str) – Operation result identifier.
  - status (str or AsyncOperationStatus) – Status of an async operation. Possible values include: ‘Started’, ‘InProgress’, ‘Succeeded’, ‘Failed’
  - started (datetime) – Start time of an async operation. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.
  - updated (datetime) – Last update time of an async operation. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.
  - result_info (str) – Optional result info.
  - error (ErrorResponseBody) – Error Body Contract

  Variables: | action_log (list[OperationResultLogItemContract]) – This property if only provided as part of the TenantConfiguration_Validate operation. It contains the log the entities which will be updated/created/deleted as part of the TenantConfiguration_Deploy operation.

class `azure.mgmt.apimanagement.models.``DeployConfigurationParameters`(*, branch: str, force: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Deploy Tenant Configuration Contract.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - branch (str) – Required. The name of the Git branch from which the configuration is to be deployed to the configuration database.
  - force (bool) – The value enforcing deleting subscriptions to products that are deleted in this update.

class `azure.mgmt.apimanagement.models.``SaveConfigurationParameter`(*, branch: str, force: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Save Tenant Configuration Contract details.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - branch (str) – Required. The name of the Git branch in which to commit the current configuration snapshot.
  - force (bool) – The value if true, the current configuration database is committed to the Git repository, even if the Git repository has newer changes that would be overwritten.

class `azure.mgmt.apimanagement.models.``AccessInformationContract`(*, id: str = None, primary_key: str = None, secondary_key: str = None, enabled: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Tenant access information contract of the API Management service.

  Parameters:

  - id (str) – Identifier.
  - primary_key (str) – Primary access key.
  - secondary_key (str) – Secondary access key.
  - enabled (bool) – Determines whether direct access is enabled.

class `azure.mgmt.apimanagement.models.``AccessInformationUpdateParameters`(*, enabled: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Tenant access information update parameters.

  Parameters: | enabled (bool) – Determines whether direct access is enabled.

class `azure.mgmt.apimanagement.models.``UserTokenResult`(*, value: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Get User Token response details.

  Parameters: | value (str) – Shared Access Authorization token for the User.

class `azure.mgmt.apimanagement.models.``UserTokenParameters`(*, expiry, key_type='primary', **kwargs)

  Bases: `msrest.serialization.Model`

  Get User Token parameters.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - key_type (str or KeyType) – Required. The Key to be used to generate token for user. Possible values include: ‘primary’, ‘secondary’. Default value: “primary” .
  - expiry (datetime) – Required. The Expiry time of the Token. Maximum token expiry time is set to 30 days. The date conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the ISO 8601 standard.

class `azure.mgmt.apimanagement.models.``GenerateSsoUrlResult`(*, value: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Generate SSO Url operations response details.

  Parameters: | value (str) – Redirect Url containing the SSO URL value.

class `azure.mgmt.apimanagement.models.``UserUpdateParameters`(*, state='active', note: str = None, identities=None, email: str = None, password: str = None, first_name: str = None, last_name: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  User update parameters.

  Parameters:

  - state (str or UserState) – Account state. Specifies whether the user is active or not. Blocked users are unable to sign into the developer portal or call any APIs of subscribed products. Default state is Active. Possible values include: ‘active’, ‘blocked’, ‘pending’, ‘deleted’. Default value: “active” .
  - note (str) – Optional note about a user set by the administrator.
  - identities (list[UserIdentityContract]) – Collection of user identities.
  - email (str) – Email address. Must not be empty and must be unique within the service instance.
  - password (str) – User Password.
  - first_name (str) – First name.
  - last_name (str) – Last name.

class `azure.mgmt.apimanagement.models.``UserCreateParameters`(*, email: str, first_name: str, last_name: str, state='active', note: str = None, identities=None, password: str = None, confirmation=None, **kwargs)

  Bases: `msrest.serialization.Model`

  User create details.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - state (str or UserState) – Account state. Specifies whether the user is active or not. Blocked users are unable to sign into the developer portal or call any APIs of subscribed products. Default state is Active. Possible values include: ‘active’, ‘blocked’, ‘pending’, ‘deleted’. Default value: “active” .
  - note (str) – Optional note about a user set by the administrator.
  - identities (list[UserIdentityContract]) – Collection of user identities.
  - email (str) – Required. Email address. Must not be empty and must be unique within the service instance.
  - first_name (str) – Required. First name.
  - last_name (str) – Required. Last name.
  - password (str) – User Password. If no value is provided, a default password is generated.
  - confirmation (str or Confirmation) – Determines the type of confirmation e-mail that will be sent to the newly created user. Possible values include: ‘signup’, ‘invite’

class `azure.mgmt.apimanagement.models.``ApiRevisionInfoContract`(*, source_api_id: str = None, api_version_name: str = None, api_revision_description: str = None, api_version_set=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Object used to create an API Revision or Version based on an existing API Revision.

  Parameters:

  - source_api_id (str) – Resource identifier of API to be used to create the revision from.
  - api_version_name (str) – Version identifier for the new API Version.
  - api_revision_description (str) – Description of new API Revision.
  - api_version_set (ApiVersionSetContractDetails) – Version set details

class `azure.mgmt.apimanagement.models.``QuotaCounterValueContract`(*, calls_count: int = None, kb_transferred: float = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Quota counter value details.

  Parameters:

  - calls_count (int) – Number of times Counter was called.
  - kb_transferred (float) – Data Transferred in KiloBytes.

class `azure.mgmt.apimanagement.models.``ApiContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `ApiContract` object

class `azure.mgmt.apimanagement.models.``TagResourceContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `TagResourceContract` object

class `azure.mgmt.apimanagement.models.``ApiRevisionContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `ApiRevisionContract` object

class `azure.mgmt.apimanagement.models.``ApiReleaseContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `ApiReleaseContract` object

class `azure.mgmt.apimanagement.models.``OperationContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `OperationContract` object

class `azure.mgmt.apimanagement.models.``TagContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `TagContract` object

class `azure.mgmt.apimanagement.models.``ProductContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `ProductContract` object

class `azure.mgmt.apimanagement.models.``SchemaContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `SchemaContract` object

class `azure.mgmt.apimanagement.models.``DiagnosticContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `DiagnosticContract` object

class `azure.mgmt.apimanagement.models.``IssueContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `IssueContract` object

class `azure.mgmt.apimanagement.models.``IssueCommentContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `IssueCommentContract` object

class `azure.mgmt.apimanagement.models.``IssueAttachmentContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `IssueAttachmentContract` object

class `azure.mgmt.apimanagement.models.``TagDescriptionContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `TagDescriptionContract` object

class `azure.mgmt.apimanagement.models.``ApiVersionSetContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `ApiVersionSetContract` object

class `azure.mgmt.apimanagement.models.``AuthorizationServerContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `AuthorizationServerContract` object

class `azure.mgmt.apimanagement.models.``BackendContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `BackendContract` object

class `azure.mgmt.apimanagement.models.``CacheContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `CacheContract` object

class `azure.mgmt.apimanagement.models.``CertificateContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `CertificateContract` object

class `azure.mgmt.apimanagement.models.``OperationPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `Operation` object

class `azure.mgmt.apimanagement.models.``ResourceSkuResultPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `ResourceSkuResult` object

class `azure.mgmt.apimanagement.models.``ApiManagementServiceResourcePaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `ApiManagementServiceResource` object

class `azure.mgmt.apimanagement.models.``EmailTemplateContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `EmailTemplateContract` object

class `azure.mgmt.apimanagement.models.``GroupContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `GroupContract` object

class `azure.mgmt.apimanagement.models.``UserContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `UserContract` object

class `azure.mgmt.apimanagement.models.``IdentityProviderContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `IdentityProviderContract` object

class `azure.mgmt.apimanagement.models.``LoggerContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `LoggerContract` object

class `azure.mgmt.apimanagement.models.``NotificationContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `NotificationContract` object

class `azure.mgmt.apimanagement.models.``OpenidConnectProviderContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `OpenidConnectProviderContract` object

class `azure.mgmt.apimanagement.models.``SubscriptionContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `SubscriptionContract` object

class `azure.mgmt.apimanagement.models.``PropertyContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `PropertyContract` object

class `azure.mgmt.apimanagement.models.``RegionContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `RegionContract` object

class `azure.mgmt.apimanagement.models.``ReportRecordContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `ReportRecordContract` object

class `azure.mgmt.apimanagement.models.``RequestReportRecordContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `RequestReportRecordContract` object

class `azure.mgmt.apimanagement.models.``UserIdentityContractPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `UserIdentityContract` object

class `azure.mgmt.apimanagement.models.``ExportResultFormat`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `open_api` = 'openapi-link'

    Export the Api Definition in OpenApi Specification 3.0 to Storage Blob.

  `swagger` = 'swagger-link-json'

    The Api Definition is exported in OpenApi Specification 2.0 format to the Storage Blob.

  `wadl` = 'wadl-link-json'

    Export the Api Definition in WADL Schema to Storage Blob.

  `wsdl` = 'wsdl-link+xml'

    The Api Definition is exported in WSDL Schema to Storage Blob. This is only supported for APIs of Type soap

class `azure.mgmt.apimanagement.models.``ProductState`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `not_published` = 'notPublished'
  `published` = 'published'

class `azure.mgmt.apimanagement.models.``BearerTokenSendingMethods`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `authorization_header` = 'authorizationHeader'

    Access token will be transmitted in the Authorization header using Bearer schema

  `query` = 'query'

    Access token will be transmitted as query parameters.

class `azure.mgmt.apimanagement.models.``Protocol`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `http` = 'http'
  `https` = 'https'

class `azure.mgmt.apimanagement.models.``ContentFormat`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `openapi` = 'openapi'

    The contents are inline and Content Type is a OpenApi 3.0 Document in YAML format.

  `openapi_link` = 'openapi-link'

    The Open Api 3.0 document is hosted on a publicly accessible internet address.

  `openapijson` = 'openapi+json'

    The contents are inline and Content Type is a OpenApi 3.0 Document in JSON format.

  `swagger_json` = 'swagger-json'

    The contents are inline and Content Type is a OpenApi 2.0 Document.

  `swagger_link_json` = 'swagger-link-json'

    The Open Api 2.0 document is hosted on a publicly accessible internet address.

  `wadl_link_json` = 'wadl-link-json'

    The WADL document is hosted on a publicly accessible internet address.

  `wadl_xml` = 'wadl-xml'

    The contents are inline and Content type is a WADL document.

  `wsdl` = 'wsdl'

    The contents are inline and the document is a WSDL/Soap document.

  `wsdl_link` = 'wsdl-link'

    The WSDL document is hosted on a publicly accessible internet address.

class `azure.mgmt.apimanagement.models.``SoapApiType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `soap_pass_through` = 'soap'

    Imports the Soap API having a SOAP front end.

  `soap_to_rest` = 'http'

    Imports a SOAP API having a RESTful front end.

class `azure.mgmt.apimanagement.models.``ApiType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `http` = 'http'
  `soap` = 'soap'

class `azure.mgmt.apimanagement.models.``State`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `closed` = 'closed'

    The issue was closed.

  `open` = 'open'

    The issue is opened.

  `proposed` = 'proposed'

    The issue is proposed.

  `removed` = 'removed'

    The issue was removed.

  `resolved` = 'resolved'

    The issue is now resolved.

class `azure.mgmt.apimanagement.models.``SamplingType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `fixed` = 'fixed'

    Fixed-rate sampling.

class `azure.mgmt.apimanagement.models.``AlwaysLog`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `all_errors` = 'allErrors'

    Always log all erroneous request regardless of sampling settings.

class `azure.mgmt.apimanagement.models.``PolicyContentFormat`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `rawxml` = 'rawxml'

    The contents are inline and Content type is a non XML encoded policy document.

  `rawxml_link` = 'rawxml-link'

    The policy document is not Xml encoded and is hosted on a http endpoint accessible from the API Management service.

  `xml` = 'xml'

    The contents are inline and Content type is an XML document.

  `xml_link` = 'xml-link'

    The policy XML document is hosted on a http endpoint accessible from the API Management service.

class `azure.mgmt.apimanagement.models.``VersioningScheme`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `header` = 'Header'

    The API Version is passed in a HTTP header.

  `query` = 'Query'

    The API Version is passed in a query parameter.

  `segment` = 'Segment'

    The API Version is passed in a path segment.

class `azure.mgmt.apimanagement.models.``GrantType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `authorization_code` = 'authorizationCode'

    //tools.ietf.org/html/rfc6749#section-4.1.

    Type: | Authorization Code Grant flow as described https

  `client_credentials` = 'clientCredentials'

    //tools.ietf.org/html/rfc6749#section-4.4.

    Type: | Client Credentials Grant flow as described https

  `implicit` = 'implicit'

    //tools.ietf.org/html/rfc6749#section-4.2.

    Type: | Implicit Code Grant flow as described https

  `resource_owner_password` = 'resourceOwnerPassword'

    //tools.ietf.org/html/rfc6749#section-4.3.

    Type: | Resource Owner Password Grant flow as described https

class `azure.mgmt.apimanagement.models.``AuthorizationMethod`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `delete` = 'DELETE'
  `get` = 'GET'
  `head` = 'HEAD'
  `options` = 'OPTIONS'
  `patch` = 'PATCH'
  `post` = 'POST'
  `put` = 'PUT'
  `trace` = 'TRACE'

class `azure.mgmt.apimanagement.models.``ClientAuthenticationMethod`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `basic` = 'Basic'

    Basic Client Authentication method.

  `body` = 'Body'

    Body based Authentication method.

class `azure.mgmt.apimanagement.models.``BearerTokenSendingMethod`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `authorization_header` = 'authorizationHeader'
  `query` = 'query'

class `azure.mgmt.apimanagement.models.``BackendProtocol`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `http` = 'http'

    The Backend is a RESTful service.

  `soap` = 'soap'

    The Backend is a SOAP service.

class `azure.mgmt.apimanagement.models.``SkuType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `basic` = 'Basic'

    Basic SKU of Api Management.

  `consumption` = 'Consumption'

    Consumption SKU of Api Management.

  `developer` = 'Developer'

    Developer SKU of Api Management.

  `premium` = 'Premium'

    Premium SKU of Api Management.

  `standard` = 'Standard'

    Standard SKU of Api Management.

class `azure.mgmt.apimanagement.models.``ResourceSkuCapacityScaleType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `automatic` = 'automatic'

    Supported scale type automatic.

  `manual` = 'manual'

    Supported scale type manual.

  `none` = 'none'

    Scaling not supported.

class `azure.mgmt.apimanagement.models.``HostnameType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `developer_portal` = 'DeveloperPortal'
  `management` = 'Management'
  `portal` = 'Portal'
  `proxy` = 'Proxy'
  `scm` = 'Scm'

class `azure.mgmt.apimanagement.models.``VirtualNetworkType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `external` = 'External'

    The service is part of Virtual Network and it is accessible from Internet.

  `internal` = 'Internal'

    The service is part of Virtual Network and it is only accessible from within the virtual network.

  `none` = 'None'

    The service is not part of any Virtual Network.

class `azure.mgmt.apimanagement.models.``NameAvailabilityReason`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `already_exists` = 'AlreadyExists'
  `invalid` = 'Invalid'
  `valid` = 'Valid'

class `azure.mgmt.apimanagement.models.``Confirmation`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `invite` = 'invite'

    Send an e-mail inviting the user to sign-up and complete registration.

  `signup` = 'signup'

    Send an e-mail to the user confirming they have successfully signed up.

class `azure.mgmt.apimanagement.models.``UserState`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `active` = 'active'

    User state is active.

  `blocked` = 'blocked'

    User is blocked. Blocked users cannot authenticate at developer portal or call API.

  `deleted` = 'deleted'

    User account is closed. All identities and related entities are removed.

  `pending` = 'pending'

    User account is pending. Requires identity confirmation before it can be made active.

class `azure.mgmt.apimanagement.models.``GroupType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `custom` = 'custom'
  `external` = 'external'
  `system` = 'system'

class `azure.mgmt.apimanagement.models.``IdentityProviderType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `aad` = 'aad'

    Azure Active Directory as Identity provider.

  `aad_b2_c` = 'aadB2C'

    Azure Active Directory B2C as Identity provider.

  `facebook` = 'facebook'

    Facebook as Identity provider.

  `google` = 'google'

    Google as Identity provider.

  `microsoft` = 'microsoft'

    Microsoft Live as Identity provider.

  `twitter` = 'twitter'

    Twitter as Identity provider.

class `azure.mgmt.apimanagement.models.``LoggerType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `application_insights` = 'applicationInsights'

    Azure Application Insights as log destination.

  `azure_event_hub` = 'azureEventHub'

    Azure Event Hub as log destination.

class `azure.mgmt.apimanagement.models.``ConnectivityStatusType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `failure` = 'failure'
  `initializing` = 'initializing'
  `success` = 'success'

class `azure.mgmt.apimanagement.models.``SubscriptionState`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `active` = 'active'
  `cancelled` = 'cancelled'
  `expired` = 'expired'
  `rejected` = 'rejected'
  `submitted` = 'submitted'
  `suspended` = 'suspended'

class `azure.mgmt.apimanagement.models.``AsyncOperationStatus`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `failed` = 'Failed'
  `in_progress` = 'InProgress'
  `started` = 'Started'
  `succeeded` = 'Succeeded'

class `azure.mgmt.apimanagement.models.``KeyType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `primary` = 'primary'
  `secondary` = 'secondary'

class `azure.mgmt.apimanagement.models.``NotificationName`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `account_closed_publisher` = 'AccountClosedPublisher'

    The following email recipients and users will receive email notifications when developer closes his account.

  `bcc` = 'BCC'

    The following recipients will receive blind carbon copies of all emails sent to developers.

  `new_application_notification_message` = 'NewApplicationNotificationMessage'

    The following email recipients and users will receive email notifications when new applications are submitted to the application gallery.

  `new_issue_publisher_notification_message` = 'NewIssuePublisherNotificationMessage'

    The following email recipients and users will receive email notifications when a new issue or comment is submitted on the developer portal.

  `purchase_publisher_notification_message` = 'PurchasePublisherNotificationMessage'

    The following email recipients and users will receive email notifications about new API product subscriptions.

  `quota_limit_approaching_publisher_notification_message` = 'QuotaLimitApproachingPublisherNotificationMessage'

    The following email recipients and users will receive email notifications when subscription usage gets close to usage quota.

  `request_publisher_notification_message` = 'RequestPublisherNotificationMessage'

    The following email recipients and users will receive email notifications about subscription requests for API products requiring approval.

class `azure.mgmt.apimanagement.models.``PolicyExportFormat`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `rawxml` = 'rawxml'

    The contents are inline and Content type is a non XML encoded policy document.

  `xml` = 'xml'

    The contents are inline and Content type is an XML document.

class `azure.mgmt.apimanagement.models.``TemplateName`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `account_closed_developer` = 'accountClosedDeveloper'
  `application_approved_notification_message` = 'applicationApprovedNotificationMessage'
  `confirm_sign_up_identity_default` = 'confirmSignUpIdentityDefault'
  `email_change_identity_default` = 'emailChangeIdentityDefault'
  `invite_user_notification_message` = 'inviteUserNotificationMessage'
  `new_comment_notification_message` = 'newCommentNotificationMessage'
  `new_developer_notification_message` = 'newDeveloperNotificationMessage'
  `new_issue_notification_message` = 'newIssueNotificationMessage'
  `password_reset_by_admin_notification_message` = 'passwordResetByAdminNotificationMessage'
  `password_reset_identity_default` = 'passwordResetIdentityDefault'
  `purchase_developer_notification_message` = 'purchaseDeveloperNotificationMessage'
  `quota_limit_approaching_developer_notification_message` = 'quotaLimitApproachingDeveloperNotificationMessage'
  `reject_developer_notification_message` = 'rejectDeveloperNotificationMessage'
  `request_developer_notification_message` = 'requestDeveloperNotificationMessage'

class `azure.mgmt.apimanagement.models.``PolicyScopeContract`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `all` = 'All'
  `api` = 'Api'
  `operation` = 'Operation'
  `product` = 'Product'
  `tenant` = 'Tenant'

class `azure.mgmt.apimanagement.models.``ExportFormat`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `openapi` = 'openapi-link'

    Export the Api Definition in OpenApi Specification 3.0 to Storage Blob.

  `swagger` = 'swagger-link'

    Export the Api Definition in OpenApi Specification 2.0 format to the Storage Blob.

  `wadl` = 'wadl-link'

    Export the Api Definition in WADL Schema to Storage Blob.

  `wsdl` = 'wsdl-link'

    Export the Api Definition in WSDL Schema to Storage Blob. This is only supported for APIs of Type soap